(function ($) {
    /*
        icon 显示统一样式  如： 点赞，分享，收藏  底部浮动框功能  
    */

    // 更改文本后，更新操作
    function v3ui_icon_update(target){
        var othis       = $(target);
        var opts        = othis.data('icon').options;

        $('div:eq(0)', othis).removeClass()
                             .addClass(opts.icon_class).addClass(opts.icon_color)
                             .css({'font-size'  : opts.icon_size, 
                                    'display'   : 'inline-block'
                                  });

        if(opts.font_display){
            var text_v = opts.font_text;
            if (text_v == '0'){
                text_v=''
            }
            $('div:eq(1)', othis).removeClass()
                                 .addClass(opts.font_color)
                                 .css({'font-size': opts.font_size
                                        })
                                 .text(text_v);
        }
    }

    // 显示样式初始化操作
    function v3ui_icon_init(target){
        var othis       = $(target);
        var opts        = othis.data('icon').options;
        var direction   = 'block';
        var padding_right = '0';

        if(opts.mode_style == 'right'){
            direction   = 'inline-block';
            padding_right = '5px';
            if(opts.font_size == null){
                opts.font_size = opts.font_size_right.font_size
            }
        }

        // 添加图标字体
        $('<div>').addClass(opts.icon_class).addClass(opts.icon_color)
                  .css({'font-size' : opts.icon_size, 
                        'display'   : 'inline-block',
                        'padding-right': padding_right
                      }).appendTo(othis);

        if(opts.font_display){
            // 添加文本字体
            if(opts.mode_style == 'middle'){


                 $('<div>').addClass(opts.font_color)
                          .css({'font-size' : opts.font_size,
                                'position'   : 'absolute',
                                'top'        : '0' ,
                                'left'      :  '55%',
                                'background-color':'#fe555c',
                                'line-height':'10px',
                                'z-index':'3',
                                'min-width':'10px',
                                'border-radius':'5px',
                                'padding':'0 2px',
                                 'white-space': 'nowrap',
                                 'box-sizing':'content-box',
                              })
                          .text(opts.font_text)
                          .appendTo(othis);

                 othis.css({'position' : 'relative'})

            }
            else {
                $('<div>').addClass(opts.font_color)
                    .css({
                        'font-size': opts.font_size,
                        'display': direction,
                    })
                    .text(opts.font_text)
                    .appendTo(othis);
            }
        }
        
    }

    $.fn.v3ui_icon = function (options) {
        if (typeof options == 'string') {
            return $.fn.v3ui_icon.methods[options].apply(this, arguments);
        }

        options = options || {};
        return this.each(function () {
            // data-icon="{'color': 'nb_orange'}" data-share=""
            var state = $.data(this, 'icon');
            if(state){
                $.extend(state.options, options);
                v3ui_icon_update(this);
            }else{
                var direction = ($(this).data('icon') && $(this).data('icon').mode_style) || $.fn.v3ui_icon.defaults.mode_style;               
                $.fn.v3ui_icon.defaults.reload_mode_style(direction);
                $.data(this, 'icon', {options: $.extend({}, $.fn.v3ui_icon.defaults, options, $(this).data('icon'))});
                v3ui_icon_init(this);
            }
        });
    };

    $.fn.v3ui_icon.defaults = {
        font_text           : '',           // 显示文字  分享(333)  点赞(2222)
        font_display        : true,
        icon_class          : '',           // 显示字体图标
        mode_style          : 'down',       // down 上下， right 左右

        reload_mode_style   : function(direction){
            if(direction == 'right'){
                this.font_size = '1em';
                this.icon_size = '1em';
                this.icon_color = 'cl-tip';
                this.font_color = 'cl-tip';
            }
            else if (direction == 'middle'){
                this.font_size = '8px';
                this.icon_size = '1.2em';
                this.icon_color = 'cl-dark';
                this.font_color = 'cl-invert';
            }
            else if (direction == 'picshow'){
                this.font_size = '8px';
                this.icon_size = '1.5em';
                this.icon_color = 'cl-invert';
                this.font_color = 'cl-invert';
            }
            else{
                this.font_size = '1em';
                this.icon_size = '1.4em';
                this.icon_color = 'cl-invert';
                this.font_color = 'cl-invert';
            }
        }

    }
})(jQuery);

(function ($) {
    /*
       分享业务控件
    */

    function v3ui_share_action(target){
        var othis           = $(target);
        var target_options  = othis.data('share').options;
        var data_options    = othis.data('options');

        if (g_browser == 'weixin'){
            var share_tip = '<div id="weixinsharetip" clickhide="destroy" style="display:none"><div>' +
                '<img src="/tina/static/app/weixin_ios_download.png" style="width:100%"/></div>' +
                '<div style="text-align:center;color:black;font-size:18px;font-weight:bold;"><div>请点击右上角菜单</div><div>选择分享到朋友圈或发送给朋友</div></div></div>'

             $.fullscreen($(share_tip), 'top', 'destroy', 0.8, 'bg-body');
        }else if(g_browser == 'app'){

             // APP的2.0以上才支，弹出选择分享到朋友圈和朋友
             if (g_app_version >= 10000){
                 var operation =   target_options.sharetype ? target_options.sharetype : 'share' ;
             }
             else{
                 // 默认分享到朋友圈
                 var operation =  target_options.sharetype ? target_options.sharetype : 'sharetimeline';
             }

             js_app_send({   'command'   :   'context' ,
                             'operation' :   operation});
        }else{
            $.v3ui_toast('请到微信或APP里分享吧！');
            return false;
        }

        // 不是myshare分享需进行数据统计  版本3.0以下的，分享后直接加
        if(othis.data('options').object_type != 'myshare' && g_app_version < 10000){
            normal_ajax('/diary/ct_share', data_options ,
                function(data){
                     if (data.retcode == 'SUCC'){

                         // 驱动展现层去展示
                         // 分享成功后，进行改变text值，.data中的 share_value 值
                         // target_options.share_value += 1;
                         // $('span', othis).text('(' + data.count_share + ')');
                         // othis.v3ui_icon({'font_text': target_options.display_num?'分享(' + target_options.share_value + ')': '分享'});

                         // if(target_options.display_only_num){
                         //    othis.v3ui_icon({'font_text': target_options.share_value});
                         // }
                         js_app_send({'command': 'refreshview' , 'hidden' : 1, 'view_name':'comment_detail'});
                     }
            });

            target_options.share_callback.call(othis, target_options.sharetype, target_options.share_value);
        }

        return false;
    }

    function v3ui_share_init(target){
        var othis           = $(target);
        var target_options  = othis.data('share').options;
        othis.v3ui_icon({   'icon_class'    :  target_options.icon_class, 
                            'icon_color'    :  target_options.icon_color, 
                            // 'font_text'     :  target_options.display_num?'分享(' + target_options.share_value + ')': '分享'
                         });

        if(target_options.display_only_num){
            othis.v3ui_icon({'font_text': target_options.share_value});
        }

        if(!target_options.disabled){
            othis.on('click', function(){
                v3ui_share_action(target);
            });
        }
    }

    $.fn.v3ui_share = function (options) {
        if (typeof options == 'string') {
            return $.fn.v3ui_share.methods[options].apply(this, arguments);
        }

        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'share');
            if(state){
                $.extend(state.options, options);
            }else{
                $.data(this, 'share', {options: $.extend({}, $.fn.v3ui_share.defaults, options, $(this).data('share'))});
                v3ui_share_init(this);
            }
        });
    }

    $.fn.v3ui_share.defaults = {
        share_value             : 0,                  // 分享的值，次数
        display_only_num        : false,
        obj_popup               : '',
        sharetype               : '',
        disabled                : false,
        icon_class              : 'v3css_icon_share',
        display_num             : true,
        share_callback          : function(){}
    }

    $.fn.v3ui_share.methods   = {
        // 分享操作
        on_share_function: function (jq) {
            return v3ui_share_action(this);
        },
        // // 获取评分数
        // share_action: share_action,

        on_share_statics: function() {
            var othis           = $(this);
            var target_options  = othis.data('share').options;
            var data_options    = othis.data('options');

            normal_ajax('/diary/ct_share', data_options,
                function(data){
                     if (data.retcode == 'SUCC'){

                         // 驱动展现层去展示
                         // 分享成功后，进行改变text值，.data中的 share_value 值
                         // target_options.share_value += 1;
                         // $('span', othis).text('(' + data.count_share + ')');
                         // othis.v3ui_icon({'font_text': target_options.display_num?'分享(' + target_options.share_value + ')': '分享'});

                         // if(target_options.display_only_num){
                         //    othis.v3ui_icon({'font_text': target_options.share_value});
                         // }
                         js_app_send({'command': 'refreshview' , 'hidden' : 1, 'view_name':'comment_detail'});
                     }
            });
        }

    }
})(jQuery);

(function ($) {
    /*
       点赞业务控件
    */
    function v3ui_praise_action(){
        if (!g_id_user_login)
            return return_with_login_and_redirect();
        var othis            = $(this);
        var data_user = othis.data('options');
        var target_options      = othis.data('praise').options;
        target_options.selected = !target_options.selected;

        $.tipsBig({
                    obj: $('div:eq(0)',othis),
                    callback: function() {
                    }
        });

        $.tipsBox({
            obj: othis,
            str: target_options.selected ?"+1":"-1",
            callback: function() {
            }
        });

        // 递归寻找父元素，直到找到类comment
        normal_ajax('/diary/ct_praise', data_user,
                    function (succ_data) {
                        if (succ_data.retcode == 'SUCC') {
                            othis.v3ui_icon({   'font_text' :  succ_data.count_praise,
                                                'icon_color':  target_options.selected ? target_options.icon_color_select: target_options.icon_color_unselect ,
                                                'mode_style':  target_options.mode_style,
                                                'icon_class':  target_options.selected?target_options.icon_class_select : target_options.icon_class_unselect,

                                            });

                        }
                    });

        return false;

    }

    function v3ui_praise_init(target){
        var othis           = $(target);
        var target_options  = othis.data('praise').options;
        othis.v3ui_icon({   'icon_class':  target_options.selected?target_options.icon_class_select : target_options.icon_class_unselect,
                            'font_text' :  target_options.praise_value,
                            'icon_color':  target_options.selected ? target_options.icon_color_select: target_options.icon_color_unselect,
                            'mode_style':  target_options.mode_style
                         });

        othis.on('click', function(){
            if(!target_options.selected){
                v3ui_praise_action.call(this);
            }
            return false;
        });

    }

    $.fn.v3ui_praise = function (options) {
        if (typeof options == 'string') {
            return $.fn.v3ui_praise.methods[options].apply(this, arguments);
        }

        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'praise');
            if(state){
                $.extend(state.options, options);
            }else{
                var direction = ($(this).data('icon') &&  $(this).data('icon').options.mode_style) || $.fn.v3ui_icon.defaults.mode_style;
                $.fn.v3ui_praise.defaults.reload_mode_style(direction);
                $.data(this, 'praise', {options: $.extend({}, $.fn.v3ui_praise.defaults, options, $(this).data('praise'))});
                v3ui_praise_init(this);
            }
        });
    };

    $.fn.v3ui_praise.defaults = {
        praise_value             : 0,                        // 点赞数
        selected                 : false,                    // 选中状态
        reload_mode_style        : function(direction){
            if(direction == 'right'){
                this.icon_color_select   = 'cl-master';     // 选中的颜色
                this.icon_class_select   = 'v3css_icon_praise';
                this.icon_color_unselect = 'cl-invert';     // 未选中的颜色
                this.icon_class_unselect = 'v3css_icon_unpraise';     // 未选中的样式
            }
            else if(direction == 'middle'){
                this.icon_color_select   = 'cl-master';     // 选中的颜色
                this.icon_class_select   = 'v3css_icon_praise';
                this.icon_color_unselect = 'cl-dark';     // 未选中的颜色
                this.icon_class_unselect = 'v3css_icon_unpraise';     // 未选中的样式
            }
            else{
                this.icon_color_select   = 'cl-master';     // 选中的颜色
                this.icon_class_select    = 'v3css_icon_praise';
                this.icon_color_unselect = 'cl-invert';     // 未选中的颜色
                this.icon_class_unselect = 'v3css_icon_unpraise';     // 未选中的样式
            }
        }
    };

    $.fn.v3ui_praise.methods   = {
        // // 获取评分数
        // share_action: share_action,
    }
})(jQuery);


(function($) {
     /*
       加减数字漂浮的特效
    */
    $.extend({
        tipsBox: function(options) {
            options = $.extend({
                obj: null,  //jq对象，要在那个html标签上显示
                str: "+1",  //字符串，要显示的内容;也可以传一段html，如: "<b style='font-family:Microsoft YaHei;'>+1</b>"
                startSize: "12px",  //动画开始的文字大小
                endSize: "30px",    //动画结束的文字大小
                interval: 600,  //动画时间间隔
                color: "red",    //文字颜色
                callback: function() {}    //回调函数
            }, options);
            $("body").append("<span class='num'>"+ options.str +"</span>");
            var box = $(".num");
            var left = options.obj.offset().left + options.obj.width() / 2;
            var top = options.obj.offset().top - options.obj.height()/2;
            box.css({
                "position": "absolute",
                "left": left + "px",
                "top": top + "px",
                "z-index": 9999,
                "font-size": options.startSize,
                "line-height": options.endSize,
                "color": options.color
            });
            box.animate({
                "font-size": options.endSize,
                "opacity": "0",
                "top": top - parseInt(options.endSize) + "px"
            }, options.interval , function() {
                box.remove();
                options.callback();
            });
        },
        tipsBig :function(options) {
            options = $.extend({
                obj: null,  //jq对象，要在那个html标签上显示
                callback: function() {}    //回调函数
            }, options);
            var box =  options.obj.clone().appendTo($('body'));
            var pos_box = options.obj.offset();
            box.css({
                "position": "absolute",
                "left": pos_box.left + "px",
                "top": pos_box.top + "px",
                "z-index": 9999
            });
            options.obj.css("visibility", "hidden");
            box.animate({
                "top": (pos_box.top - 15) + 'px',
                "left": (pos_box.left - 15) + 'px',
                "font-size":'+=' + options.obj.css('font-size')
            }, 'normal').animate({
                top: pos_box.top + 'px',
                left: pos_box.left + 'px',
                "font-size":options.obj.css('font-size')
            }, 'normal',null , function() {
                box.remove();
                options.obj.css("visibility", "inherit");
                options.callback();
            });
        }

    });
})(jQuery);


(function ($) {
    /*
     *   checkbox和radio控件
     */

    //初始化checkbox和radio
    function v3ui_checkbox_int(container) {
        var othis = $(container);
        var opts = othis.data('checkbox').options;
        $('<input>').attr({ 'type'      : opts.type, 'name': opts.name,
                            'checked'   : opts.checked, value: opts.value
                            })
                        .css('display','none').appendTo(othis);

        if (opts.checked) {
            $('<i>').addClass('o_sel').appendTo(othis);
        }
        else {
            $('<i>').addClass('o_unsel').appendTo(othis);
        }
    }

    // checkbox或radio被选中
    function v3ui_checkbox_click(container) {
        var othis = $(container);
        var input_obj = $('input', othis);

        // 如果是radio并且当前未被选中，选中当前radio，同时去掉其他同组的radio选中状态。
        if (input_obj.attr('type') == 'radio' && !(input_obj.is(":checked"))) {
            var radio_name = input_obj.attr('name');
            var radio_objs = $('input:radio[name=' + radio_name + ']');

            radio_objs.removeAttr("checked").siblings('.o_sel').removeClass('o_sel').addClass('o_unsel');

            input_obj.prop("checked", "checked");
            $('i', othis).removeClass('o_unsel').addClass('o_sel');
        }

        // 如果是checbox
        if (input_obj.attr('type') == 'checkbox') {

            // 1.当前选中改为未选中，选中改为未选中
            if (input_obj.is(":checked")) {
                $('i', othis).removeClass('o_sel').addClass('o_unsel');
                input_obj.removeAttr("checked");
            }
            else {
                $('i', othis).removeClass('o_unsel').addClass('o_sel');
                input_obj.prop("checked", "checked")
            }

            // 依据名字以‘_all’检查当前是组的全选按钮
            var checkbox_name = input_obj.attr('name');
            if (checkbox_name.endWith('_all')) {
                /**
                 * 全选按钮，则该组的其他需要全选中或不选中
                 * @type {*|HTMLElement}
                 */
                var checkbox_objs = $('input:checkbox[name=' + checkbox_name.replace('_all', '') + ']');
                if (input_obj.is(":checked")) {
                    checkbox_objs.prop("checked", "checked").siblings('.o_unsel').removeClass('o_unsel').addClass('o_sel');
                }
                else {
                    checkbox_objs.removeAttr("checked").siblings('.o_sel').removeClass('o_sel').addClass('o_unsel');
                }
            }
            else {
                /**
                 * 如果当前不是全选按钮需要检查是否有全选按钮，如果有全选按钮，则需要判断当前组所有是选中还是未选中对，全选按钮处理
                 * @type {*|HTMLElement}
                 */
                var checkbox_all_obj = $('input:checkbox[name=' + checkbox_name + '_all]:eq(0)');
                if (checkbox_all_obj) {
                    var checkbox_objs = $('input:checkbox[name=' + checkbox_name + ']');
                    if (checkbox_objs.siblings('.o_unsel').length > 0 && checkbox_all_obj.is(":checked")) {
                        checkbox_all_obj.removeAttr("checked").siblings('.o_sel').removeClass('o_sel').addClass('o_unsel');
                    }

                    if (checkbox_objs.siblings('.o_unsel').length == 0 && !checkbox_all_obj.is(":checked")) {
                        checkbox_all_obj.prop("checked", "checked").siblings('.o_unsel').removeClass('o_unsel').addClass('o_sel');
                    }
                }
            }
        }

    }

    $.fn.v3ui_checkbox = function (options, param) {
        if (typeof options == 'string') {
            return $.fn.namibox_checkbox.methods[options](this, param);
        }

        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'checkbox');
            var opts;
            if (state) {
                opts = $.extend(state.options, options);
                state.options = opts;
            } else {
                $.data(this, 'checkbox', {
                    options: $.extend({}, $.fn.v3ui_checkbox.defaults, options)
                });

                //初始化radio 和checkbox 控件
                v3ui_checkbox_int(this);
            }


        });
    };

    $.fn.v3ui_checkbox.methods = {

        click: function (jq) {
            return v3ui_checkbox_click(jq[0]);
        }
    };

    $.fn.v3ui_checkbox.defaults = {
        type    :   'radio',
        size    :    '1em',
        checked :   false,
        name    :    'radio'
    };

})(jQuery);

(function($){
    /*
       收藏业务控件
    */

    //初始化
    function v3ui_favorite_init(target) {
        var othis            = $(target);
        var target_options      = othis.data('favorite').options;
        var opts = othis.data('options');

        othis.v3ui_icon({ 'font_text' :  target_options.selected ? '已收藏':'收藏',
                          'icon_color':  target_options.selected ? target_options.icon_color_select: target_options.icon_color_unselect ,
                          'icon_class':  target_options.selected ? target_options.icon_class_select: target_options.icon_class_unselect });

        //绑定单击事件
        othis.on('click', function () {
            if(opts.object_id || opts.cid){
                v3ui_favorite_action(this);
            }else{
                v3ui_favorite_click(this);
            }

        });
    };

    // 点击收藏事件
    function v3ui_favorite_action(which){
        if (!g_id_user_login){
            return return_with_login_and_redirect();
        }

        var obj_cur = $(which);

        $.confirm('确认要收藏或取消收藏该信息吗？', '人教微研友情提醒', ['取消', '确认'],function (arg , defer) {
            if(arg == '确认'){
                var data_user = obj_cur.data('options');
                var target_options      = obj_cur.data('favorite').options;

                // 递归收集数据
                if(obj_cur.data('options').cid){
                    data_user = obj_cur.collect_data_user_by_parent_recurse();
                }

                normal_ajax('/diary/ct_favorite', data_user,
                    function (succ_data) {
                        target_options.selected = succ_data.retcode == 'FAVORITE' ? true : false;

                        // 收藏或取消收藏提示信息
                        var alert_text = target_options.selected ? '收藏成功':'取消收藏成功';

                        // 更改样式
                        obj_cur.v3ui_icon({ 'font_text' :  target_options.selected ? '已收藏':'收藏',
                                            'icon_color':  target_options.selected ? target_options.icon_color_select: target_options.icon_color_unselect ,
                                            'icon_class':  target_options.selected ? target_options.icon_class_select: target_options.icon_class_unselect });

                        // 特效
                        $.tipsBig({
                            obj: $('div:eq(0)',obj_cur),
                            callback: function() {
                                 return false;
                            }
                        });

                    });
            }
        });
        return false;
    }

    // 演示用单击事件
    function v3ui_favorite_click(which) {
        // 响应回调方法
        var othis            = $(which);
        othis.data('footer');
        var target_options      = othis.data('favorite').options;

        // 改变选中状态
        target_options.selected           = target_options.selected ? false:true;

        // 收藏或取消收藏提示信息
        var alert_text = target_options.selected ? '收藏成功':'取消收藏成功';
        //alert(alert_text);

        // 更改样式
        othis.v3ui_icon({ 'font_text' :  target_options.selected ? '已收藏':'收藏',
                          'icon_color':  target_options.selected ? target_options.icon_color_select: target_options.icon_color_unselect ,
                          'icon_class':  target_options.selected ? target_options.icon_class_select: target_options.icon_class_unselect });

        // 特效
        $.tipsBig({
            obj: $('div:eq(0)',othis),
            callback: function() {
                //alert(5);
            }
        });

        target_options.onClick.call(which);
    };


    $.fn.v3ui_favorite = function (options, param) {

        if (typeof options == 'string') {
            return $.fn.v3ui_favorite.methods[options](this, param);
        }

        //自动执行初始化函数
        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'collect');
            if (state) {
                $.extend(state.options, options);
            } else {
                var direction = $(this).data('icon').options.mode_style || $.fn.v3ui_icon.defaults.mode_style;
                $.fn.v3ui_favorite.defaults.reload_mode_style(direction);

                $.data(this, 'favorite', {options: $.extend({}, $.fn.v3ui_favorite.defaults, options, $(this).data('favorite'))});
                v3ui_favorite_init(this);
            }
        });
    };

    $.fn.v3ui_favorite.defaults = {
        selected                 : false,              // 选中状态

        onClick: function () {
        },
        reload_mode_style   : function(direction){
            if(direction == 'right'){
                this.icon_class_select   = 'v3css_icon_favourate';           // 收藏选中的图片
                this.icon_class_unselect = 'v3css_icon_favourate_outline';   // 收藏未选中的图片
                this.icon_color_select   = 'cl-master';                      // 收藏选中的颜色
                this.icon_color_unselect = 'cl-invert';                      // 收藏未选中的颜色
            }
            else if(direction == 'middle'){
                this.icon_class_select   = 'v3css_icon_mask';
                this.icon_class_unselect = 'v3css_icon_mask_outline';
                this.icon_color_select   = 'cl-master';                      // 收藏选中的颜色
                this.icon_color_unselect = 'cl-dark';                      // 收藏未选中的颜色
            }
            else{
                this.icon_class_select   = 'v3css_icon_mask';
                this.icon_class_unselect = 'v3css_icon_mask_outline';
                this.icon_color_select   = 'cl-master';                      // 收藏选中的颜色
                this.icon_color_unselect = 'cl-invert';                      // 收藏未选中的颜色
            }
        }
    };
})(jQuery);


(function($){
    /*
       设置星评控件
    */
    //设置星评分数值
    function v3ui_stars_set_scores(obj, value){
        var target_options  = obj.data('v3ui_stars').options;
        if(value < 0 || value > target_options.scores){
            $.alert('输入分数不合法！');
            return false;
        }

        target_options.current_scores = value;
        obj.find('.solid_star').width(((100*value)/target_options.scores) + '%');
    }

    function v3ui_stars_select_mobile(obj, e, target_options){
        /*
           app中滑动操作
        */
        var star        = obj.closest('.star');
        var solid_star  = star.find('.solid_star');

        solid_star.width(e.originalEvent.touches[0].pageX - solid_star.offset().left);

        var score = solid_star.width()/star.width();
        if(score > 1){
            score = 1;
        }
        if(score < 0){
            score = 0;
        }

        // 将分数值记录到 评星元素.v3ui_stars 中，同时调用回调函数
        score = (score * target_options.scores).toFixed(1);
        target_options.current_scores = score;
        
        target_options.onSelectStar.call(star.closest('.v3ui_stars'), score);  
    }

    function v3ui_stars_select_pc(obj, e, target_options){
        /*
            PC 端滑动相应事件
        */
        var star        = obj.closest('.star');
        var solid_star  = star.find('.solid_star');
        solid_star.width(e.pageX - solid_star.offset().left);

        // 将分数值记录到 评星元素.v3ui_stars 中，同时调用回调函数
        var score = ((solid_star.width()/star.width())*target_options.scores).toFixed(1);
        target_options.current_scores = score;

        target_options.onSelectStar.call(star.closest('.v3ui_stars'), score);  
    }

    function v3ui_stars_init(target){
        /*
            初始化星评， 如有两颗星，满分五分， 则标签下的元素结构应为：
            <div class="v3ui_stars"
                <div class="star">
                    <div>
                        <span class="v3css_icon_mask" ></span><span class="v3css_icon_mask">
                    </div>

                    <div class="solid_star">
                        <span class="v3css_icon_mask" ></span><span class="v3css_icon_mask">
                    </div>
                </div>
            </div>
        */
        var othis           = $(target);

        var target_options  = othis.data('v3ui_stars').options;

        // 清空othis元素的文本
        othis.text('');

        // 创建实体星，空心星
        var star            = $('<div class="star">'),
            solid_star      = $('<div class="solid_star">').addClass(target_options.star_color),
            empty_star      = $('<div>').addClass(target_options.outline_color);

        for(var i = 0; i < target_options.stars_num; i ++){
            solid_star.append($('<span class="v3css_icon_mask" >'));
            empty_star.append($('<span class="v3css_icon_mask" >'));
        }

        star.append(empty_star).append(solid_star).appendTo(othis);

        if(target_options.star_editable){
            $('.v3css_icon_mask', solid_star).css('cursor', 'pointer');
            $('.v3css_icon_mask', empty_star).css('cursor', 'pointer');

            $('.v3css_icon_mask', star).bind({
                click: function(e){
                    e.preventDefault();
                    v3ui_stars_select_pc($(this), e, target_options);

                    return false;
                },
                touchmove: function(e){
                    e.preventDefault();
                    v3ui_stars_select_mobile($(this), e, target_options);

                    return false;
                }
            });
        }
        // 设置星评默认值
        v3ui_stars_set_scores(othis,  target_options.current_scores);
    }

    $.fn.v3ui_stars = function(options, param){
        /*
            初始化星评
        */
        if (typeof options == 'string'){
            return $.fn.v3ui_stars.methods[options](this, param);
        }

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'v3ui_stars');
            if (state){
                $.extend(state.options, options);
            } else {
                $.data(this, 'v3ui_stars', {
                    options: $.extend({}, $.fn.v3ui_stars.defaults, options, $(this).data('options'))
                });
                v3ui_stars_init(this);
            }
        });
    };

    $.fn.v3ui_stars.defaults = {
        stars_num           : 5,            // 默认五颗星
        scores              : 5,            // 默认五分
        star_color          : 'cl-red',     // 默认星评颜色orange
        outline_color       : 'cl-assist',  // 评星外框颜色
        star_editable       : false,        // 是否支持修改
        current_scores      : 0,            // 当前分数值

        // 选择评星的回调函数
        onSelectStar        : function(score){
            var textObj = $(this).closest('.ct_starnk').find('#val_rank_show');
            if(textObj.length > 0){
                textObj.text((score/10).toFixed(1));
            }
        }
    };

    $.fn.v3ui_stars.methods   = {

        // 获取评分数  val
        val: function(obj){return (obj.data('v3ui_stars').options.current_scores/10).toFixed(1)},

        // 设置星评数
        set_scores: v3ui_stars_set_scores
    }

})(jQuery);


(function ($) {
    /*
        TAB控件
     */

    //初始化
    function v3ui_tabs_init(container) {
        var othis = $(container);

        //判断TAB个数并设置其宽度
        var tab_length = $(".tabs_title", othis).length;
        $(".tabs_title", othis).css('width', 100 / tab_length + "%").addClass("cl-tip");

        var panel_id = $(".tabs_selected", othis).attr("id").replace("tab_", "") - 1;
        $(".panel", othis).eq(panel_id).show().after_show().siblings().hide();

        // 列表模式模式
        if (othis.hasClass("v3css_tabs")){
            //设置TAB头和PANEL的选中和非选中样式
            $(".tabs_selected", othis).removeClass("cl-tip").addClass("bg-master cl-invert");
            $("td", othis).addClass("dc-master");
        }else{
            //设置TAB头和PANEL的选中和非选中样式
            $(".tabs_selected", othis).addClass("cl-master").addClass("dc-master");
        }

        //绑定单击事件
        $(".tabs_header").on(g_clickevent, ".tabs_title", function () {
            v3ui_tabs_select(container, this);
        });
    };

    //TAB单击事件
    function v3ui_tabs_select(container, which) {
        var othis = $(container);
        var cur = $(which);

        //单击选中页签或者页签中含有a标签直接返回
        if (cur.hasClass('tabs_selected') || $("a", cur).length > 0) {
            return false;
        }
        event.preventDefault();

        // 列表模式模式，更改TAB选中状态
        if (othis.hasClass("v3css_tabs")){
            $(".tabs_selected", othis).removeClass("tabs_selected bg-master cl-invert").addClass("cl-tip");
            cur.addClass("tabs_selected").addClass("bg-master cl-invert").removeClass("cl-tip");
        }else{
            $(".tabs_selected", othis).removeClass("tabs_selected  dc-master");
            $(".tabs_title", othis).removeClass("cl-master");
            cur.addClass("tabs_selected").addClass("cl-master").addClass("dc-master");
        }

        // 变换对应的PANEL
        var panel_id = cur.attr("id").replace("tab_", "");
        // 先隐藏未选中的后展示选中的
        var cur_panel = $(".panel", othis).eq(panel_id - 1);
        cur_panel.siblings().hide(0,function(){});
        cur_panel.show(0,function(){
            $(this).after_show();
        });

        //响应回调方法
        var opts = $.data(container, "tabs").options;
        opts.onSelect.call(container, cur.text(), v3ui_tabs_getTabIndex(container, which));
        return false;
    };

    //获取TAB选项名称
    function v3ui_tabs_getTabName(container) {
        var othis = $(container);
        var text = $(".tabs_selected", othis).text();
        $.alert(text);
        return false;
    };

    //创建新Tab
    function v3ui_tabs_addTab(container, options) {
        var othis = $(container);
        var title = options.title;

        var tab_length = $(".tabs_title", othis).length + 1;

        $("<td>").attr("id", "tab_" + tab_length).addClass("tabs_title").text(title + tab_length).addClass("cl-tip").appendTo($("tr", othis));
        $("<div>").attr("id", "panel_" + tab_length).addClass("panel").css("display", "none").text(tab_length).appendTo($(".tabs_panels", othis));

        $(".tabs_title", othis).css("width", 100 / tab_length + "%");

        // 列表模式模式
        if (othis.hasClass("v3css_tabs")) {
            $("td", othis).addClass("dc-master");
        }
    };

    //获取tab索引ID
    function v3ui_tabs_getTabIndex(container, tab) {
        return $('.tabs_selected' , $(container)).index();
    }

    $.fn.v3ui_tabs = function (options, param) {

        if (typeof options == "string") {
            return $.fn.v3ui_tabs.methods[options](this, param);
        }

        //自动执行初始化函数
        options = options || {};
        return this.each(function () {
            var state = $.data(this, "tabs");
            if (state) {
                $.extend(state.options, options);
            } else {
                $.data(this, "tabs", {
                    options: $.extend({}, $.fn.v3ui_tabs.defaults, options, $(this).data('options')),
                    tabs: []
                });
                v3ui_tabs_init(this);
            }
        });
    };

    $.fn.v3ui_tabs.methods = {
        getName: function (jq) {
            return jq.each(function () {
                v3ui_tabs_getTabName(jq[0]);
            });
        },
        add: function (jq, options) {
            return jq.each(function () {
                v3ui_tabs_addTab(jq[0], options);
            });
        },
        getTabIndex: function (jq, tab) {
            return v3ui_tabs_getTabIndex(jq[0], tab);
        }
    };

    $.fn.v3ui_tabs.defaults = {
        onSelect: function (title, index) {
        }
    };
})(jQuery);


(function ($) {
    /*
    播放进度条控件
    */

    //初始化
    function v3ui_play_progress_init(container) {
        var othis        = $(container);
        var opts         = othis.data('playprogress').options;
        //绑定点击事件
        $('.clickbar', othis).bind(g_clickevent, function (e) {
            v3ui_play_progress_clicked(container, e);
        });
        v3ui_play_progress_update(container);
    }

    // 更新操作
    function v3ui_play_progress_update(container){
        var othis               = $(container);
        var opts                = othis.data('playprogress').options;
        var pos_bar_width       = 0;
        opts.position = Math.max( 0, opts.position );
        opts.duration = Math.max(0, opts.duration);
        opts.position = Math.min( opts.position, opts.duration );

        if (opts.duration > 0){
            pos_bar_width       = opts.position/opts.duration * $(".clickbar", othis).width();
        }
        $(".curpos", othis).text(fmt_time(opts.position));
        $(".posbar", othis).css({'width':pos_bar_width});
        $(".posblock", othis).css({'left':pos_bar_width - 1});
        $(".duration", othis).text(fmt_time(opts.duration));
    }

    //处理点击事件, 计算进度条的位置
    function v3ui_play_progress_clicked(container, e){
        var othis        = $(container);
        var opts        = othis.data('playprogress').options;
        if(opts.duration <= 0){//总进度没有回来之前无法进行计算，直接返回
            return;
        }
        if (g_clickevent == 'touchstart'){
            offsetX = e.originalEvent.targetTouches[0].pageX  - $(".clickbar", othis).offset().left;
        }
        else{
            offsetX = e.offsetX;
        }
        var clickbar_width = $(".clickbar", othis).width();
        var cur_pos_time   = offsetX/clickbar_width * opts.duration;
        opts.position      = cur_pos_time;
        v3ui_play_progress_update(container);
        opts.onEventPostChange.call(othis, opts.position , opts.duration);
    }

    //设置位置信息
    function v3ui_play_progress_set_pos(container, params){
        var othis        = $(container);
        var opts         = othis.data('playprogress').options;
        opts.position    = params.cur_time;
        opts.duration    = params.duration_time;
        v3ui_play_progress_update(container);
    }

    //扩展函数
    $.fn.v3ui_play_progress = function (options) {
        if (typeof options == 'string') {
            return $.fn.v3ui_play_progress.methods[options].apply(this, arguments);
        }

        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'playprogress');
            if(state){
                $.extend(state.options, options);
                v3ui_play_progress_update(this);
            }else{
                $.data(this, 'playprogress', {options: $.extend({}, $.fn.v3ui_play_progress.defaults, options, $(this).data('playprogress'))});
                v3ui_play_progress_init(this);
            }
        });
    };

    $.fn.v3ui_play_progress.defaults = {
        position              : 0,     //当前位置
        duration              : 0,     //总时长
        onEventPostChange     : function(){}
    };

    //可以调用和字符串相符的函数
    $.fn.v3ui_play_progress.methods   = {
        //设置当前位置
        set_pos:function (container, options){
            v3ui_play_progress_set_pos(this, options)
        }
    }

})(jQuery);


(function ($) {
    /*
        FORM
     */

    $.fn.v3ui_forms = function(options, param){
        if (typeof(options) == 'string'){
            if (options in $.fn.v3ui_forms.methods)
                return $.fn.v3ui_forms.methods[options](this, param);
            else
                return;
        }

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'forms');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'forms', {
                    options: $.extend({}, $.fn.v3ui_forms.defaults, options)
                });
            }
        });
    };

    $.fn.v3ui_forms.defaults = {
        on_submit_check :   null,
        on_submit_done  :   null,
        on_submit_error :   null
    };

    $.fn.v3ui_forms.methods = {

        lock_form_submit: function(forms){
            if(forms.attr('doing') == 'true'){
                return true;
            }else{
                forms.attr('doing', 'true');
                return false;
            }
        },

        unlock_form_submit: function(forms){
            forms.removeAttr('doing');
        },

        // 收集FORM内的数据，支持（1）标准HTML的INPUT（2）V2版本的若干控件，未来废弃（3）V3版本控件
        collect_data: function (forms) {
            var data_form = forms.v3ui_serialize(true);

            var vals_ret = [];

            var json_ret = {};
            for (var index = 0 ; index < data_form.length ; index++)
                push_data_in_json_ret(json_ret , data_form[index].name , data_form[index].value);

            for (index = 0 ; index < vals_ret.length ; index++){
                var val_ret = vals_ret[index];
                for (var val_key in val_ret){
                    push_data_in_json_ret(json_ret , val_key , val_ret[val_key]);
                }
            }

            return json_ret;
        },

        // 提交函数
        submit: function(forms){

            // TODO:锁定formt提交，防止重入
            if(forms.v3ui_forms('lock_form_submit')){
                return false;
            }

            // 准备提交的相关数据数组
            // （1）类型，如submit,v2_image_upload（2）函数（3）附加参数（4）提示信息
            var list_submit = [['userform_submit' , userform_submit , null , '提交用户数据']];

            if(g_browser != 'app'){
                // 扫描所有的V2版本的imgupload，找出其中已经选择了图片文件的
                // 该函数返回的是[内嵌的FORM LIST,提交函数]
                var v2_img_upload_forms = $('.v3ui_image_upload' , forms).v3ui_image_upload('forms');
                for (var index = v2_img_upload_forms[0].length - 1; index >= 0 ; index --)
                    list_submit.push(['v2_image_upload' , v2_img_upload_forms[1] , v2_img_upload_forms[0][index] , '上传第' + (index + 1) + '张图片']);
            }

            // 看是否需要进行提交前的检查
            var state = $.data(forms[0], 'forms');
            if (state && state.options.on_submit_check && $.isFunction(state.options.on_submit_check)){

                var vals_user = forms.v3ui_forms('collect_data');
                $.extend(vals_user, forms.query_attribute_into_map());
                async(state.options.on_submit_check(forms , vals_user , false /* 表示提交前检查 */))
                        .done(continue_submit).fail(forms.v3ui_forms('unlock_form_submit'));// TODO:通过fail回调unlock_form_submit（提交前检查失败出口）
            }
            else{
                continue_submit();
            }

            // 提交调度函数
            function continue_submit(data_server_response){
                if (!list_submit.length){
                    // 所有都成功提交了，回调结果函数
                    //console.debug('提示：全部提交成功！');

                    if (state && state.options.on_submit_done && $.isFunction(state.options.on_submit_done))
                        state.options.on_submit_done(forms , data_server_response);
                    // TODO:forms提交成功后的出口（第二个出口）

                    forms.v3ui_forms('unlock_form_submit');
                    return;
                }

                var obj_next_sumit = list_submit.pop();

                // V2版本的image_upload的调用函数是v3ui_image_upload_submit(obj_form , callback , callargs)，统一到该模式
                //console.debug('提示：进行' + obj_next_sumit[0] + '提交！');
                $.v3ui_runstatus(obj_next_sumit[3] , 'running' , false);
                obj_next_sumit[1](obj_next_sumit[2], v3ui_form_submit_callback);
            }

            // V2版本的image_upload回调函数定义是callback(true , obj_form , callargs-附加参数 , data-服务器返回结果);
            // 作为userform_submit的回调函数
            function v3ui_form_submit_callback(is_succ , obj_form , callargs , data_server_response){
                if (!is_succ || data_server_response.retcode != 'SUCC'){
                    // console.debug('错误：v3ui_form_submit_callback侦听到提交错误！');
                    $.v3ui_runstatus('系统错误：' + (data_server_response ? data_server_response.description || '未知错误！' : '请稍后重试！') , 'error' , 'destroy')

                    if (state && state.options.on_submit_error && $.isFunction(state.options.on_submit_error))
                        state.options.on_submit_error(forms , data_server_response);

                    forms.v3ui_forms('unlock_form_submit');
                    // TODO:网络提交前检查失败、网络提交失败的出口（第三个出口）
                }
                else{
                    continue_submit(data_server_response);
                }

            }

            // 最终的FORM提交函数
            function userform_submit(null_arg , submit_callback){
                // 收集用户数据，图片上传后会有新的图片数据
                var vals_user = forms.v3ui_forms('collect_data');
                $.extend(vals_user, forms.query_attribute_into_map());

                if (state && state.options.on_submit_check && $.isFunction(state.options.on_submit_check)){
                    async(state.options.on_submit_check(forms , vals_user , true /* 表示图像提交后，整体提交前的检查 */))
                        .done(userform_submit_action)
                        .fail(function(){
                            v3ui_form_submit_callback(false , 'on_submit_check')
                        });
                }
                else
                    userform_submit_action();

                function userform_submit_action(){
                    var url_submit  = g_jquery_dtype == 'json' ? forms.attr('action') : g_site + forms.attr('action');

                    // 因为之前的疏忽没有控制好forms的提交数据格式，导致后端无法平滑处理POST和GET提交模式，导致处理跨域比较麻烦
                    // 这里为了兼容，对于定义了version=v2的forms，采用正确的处理方式
                    var data_submit = forms.attr('version') == 'v2' ? vals_user : $.toJSON(vals_user);
                    var method_submit = forms.attr('version') == 'v2' ? forms.attr('method') : 'POST';

                    normal_ajax(url_submit , data_submit,
                            function(succ_data){
                                console.debug(succ_data.retcode == 'SUCC' ? '提示：userform_submit提交成功！' : '提示：userform_submit提交处理失败！');
                                submit_callback(succ_data.retcode == 'SUCC' , 'userform_submit' , null , succ_data);
                            },
                            function(fail_data){
                                console.debug('提示：userform_submit提交失败！');
                                submit_callback(false , 'userform_submit' , null , fail_data);
                            },
                            null , method_submit , g_jquery_dtype);
                }
            }
        }
    }
})(jQuery);


(function ($) {
    /*
        .v3ui_inputip支持inputip风格，在没有输入的时候，用灰色显示提示文字
     */

    function v3ui_inputip_init(target) {

        $(target).each(function () {
            $(this).bind('blur', function () {
                var othis = $(this);

                if (!othis.val()) {
                    othis.val(this.defaultValue);
                    othis.addClass('cl-tip').removeClass('cl-default');

                    if (othis.hasClass('v3co_password'))
                        this.type = 'text';
                }
            }).bind('focus', function () {
                var othis = $(this);

                if (othis.val() == this.defaultValue) {
                    othis.val('');
                }
                othis.removeClass('cl-tip').addClass('cl-default');

                if (othis.hasClass('v3co_password'))
                    this.type = 'password';
            })
        });
    }

    $.fn.v3ui_inputip = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_inputip.methods ? $.fn.v3ui_inputip.methods[options](this, param) : null;

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'inputip');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'inputip', {
                    options: $.extend({}, $.fn.v3ui_forms.defaults, options)
                });

                v3ui_inputip_init(this);
            }
        });
    };
})(jQuery);

(function($){
    /*
       评论控件
    */

    function v3ui_comment_init(target){
        var othis           = $(target);
        var target_options  = othis.data('v3ui_comment').options;
        var forbidden       = ['禁言', '谢谢'].indexOf(target_options.text);
        othis.v3ui_icon({   'icon_class'    :  forbidden == -1 ?target_options.icon_class : target_options.forbidden_cls,
                            'icon_color'    :  target_options.icon_color,
                            'font_text'     :  target_options.text
                         });

        if(forbidden == -1 && !target_options.disabled && !g_user_comment_limit){
            if(target_options.comment_mode == 'complex'){
                // 复杂模式，直接跳转URL，带有评星功能
                othis.wrapAll('<a href="'+ target_options.url +'" targets="_comm" class="a_no_line" />');
            }else if(target_options.comment_mode == 'simple' && target_options.simple_type == 'new'){
                othis.click(function(){
                    $('#hide_default_comment').click();
                })
            }
        }

        $(othis).on('click', function () {
            if (g_user_comment_limit){
                $.v3ui_toast('抱歉，你已经被禁止发言！');
                return false;
            }
        });

    }

    $.fn.v3ui_comment = function(options, param){
        /*
            初始化评论控件
        */
        if (typeof options == 'string'){
            return $.fn.v3ui_comment.methods[options](this, param);
        }

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'v3ui_comment');
            if (state){
                $.extend(state.options, options);
            } else {
                $.data(this, 'v3ui_comment', {
                    options: $.extend({}, $.fn.v3ui_comment.defaults, options, $(this).data('comment'), $(this).data('options'))
                });
                v3ui_comment_init(this);
            }
        });
    };

    $.fn.v3ui_comment.defaults = {
        comment_mode    : 'simple',      // 评论模式  1、simple简易评论   2、complex 复杂评论，跳转页面，评星等操作的评论
        text            : '评论',         // 两种模式，1、评论  2、回复  3、谢谢  4、禁言
        icon_class      : 'v3css_icon_comment',
        forbidden_cls   : 'v3css_icon_uncomment',
        disabled        : false,
        simple_type     : 'reply',       // 简易模式(simple)下， 有两种类型  1、reply回复评论   2、new 新建评论
        onClick         : function(){}
    };

    $.fn.v3ui_comment.methods   = {
    }

})(jQuery);

(function ($) {
    /*
        LOCATION控件，支持地理定位，首先进行经纬度坐标定位，然后进行IP地址定位，失败后提示点击重试
     */

    //初始化
    function v3ui_location_init(container) {
        /* dom 结构如下：
           <div class="v3ui v3ui_location nct_unit" name="location">
               <span class="v3css_control_icon v3css_icon_location_outline"></span>
               <span class="v3css_control_text">定位中</span>
           </div>
        */

        var othis       = $(container);

        if($('.v3css_control_text', othis).text() == '定位中'){
            // 定位有三种状态  定位中，定位，定位失败
            // 状态转换：　【定位失败，定位】====定位中===【定位失败, 定位（定位成功）】

            $('.v3css_control_text', othis).text('定位');
            v3ui_location_click.call(othis);
        }

        othis.on(g_clickevent, v3ui_location_click);

        register_app_js_handle('on_appcmd_postcurposition', function (message) {
            var longitude   = message.longitude;
            var latitude    = message.latitude;
            var position    = {"coords": {"longitude": longitude, "latitude": latitude}};
            v3ui_location_by_longlatitude(position, othis);
        });
    }

    function v3ui_location_click() {

        event.preventDefault();
        var othis   = $(this);

        if(['定位失败', '定位'].indexOf($('.v3css_control_text', othis).text()) == -1){
            if ($('.v3css_control_text', othis).text() != '定位中'){
                if (check_is_function('geo_locate')){
                    geo_locate(othis);
                }
            }
            return false;
        }

        $('.v3css_control_text', othis).text('定位中');

        // 终端安卓和IOS从终端上获取位置信息，否则通过HTML5获取位置信息
        if (g_browser == 'app' && g_app_version >= 10000) {
            //alert('调用：'+g_browser+"  " + g_app_version)
            register_on_app_ready(function () {
                js_app_send({
                    'command': 'getcurposition',
                    'advance': ''
                }, function (response) {
                    // 同步改成异步调用on_appcmd_getcurposition
                });
            });
        } else {
            navigator.geolocation ? navigator.geolocation.watchPosition(
                function (position) {
                    // HTML5的定位成功通知
                    v3ui_location_by_longlatitude(position, othis);
                },
                function (error) {
                    // HTML5的定位失败通知，记录失败信息，转向IP定位

                    othis.attr('location_fail_reason', error.code + ',' + error.message);
                    v3ui_location_by_ip(othis);
                }
            ) : v3ui_location_by_ip(othis);
        }
    }

    // 用IP地址进行定位
    function v3ui_location_by_ip(othis) {
        $.ajax({
            type: 'GET',
            cache: false,
            url: '//api.map.baidu.com/location/ip?ak=3rR1T9pmVnO2WUtXfEpjWKL3&coor=bd09ll',
            dataType: 'jsonp',
            jsonp: 'callback',
            success: function (result) {
                var address_detail = result.content.address_detail;

                // 显示结果
                $('.v3css_control_text', othis).text(address_detail.city || address_detail.province || address_detail.country);
                $('.v3css_control_icon', othis).removeClass('v3css_icon_location_outline')
                    .addClass('v3css_icon_location cl-ok');

                // 保存结果
                othis.data('location').options.result = {
                    geocoding     :   '',
                    fail_reason   :   '',
                    ipadress      :   result.content.address ,
                    info_detail   :   address_detail ,
                    info_abbrev   :   address_detail.city == address_detail.province ? address_detail.province : address_detail.province + address_detail.city ,
                    country       :   '' ,
                    province      :   address_detail.province ,
                    city          :   address_detail.city
                };
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                $('.v3css_control_text', othis).text('定位失败');
                $('.v3css_control_icon', othis).removeClass('v3css_icon_location')
                    .removeClass('cl-ok')
                    .addClass('v3css_icon_location_outline');

                // 保存结果
                othis.data('location').options.result = {
                    geocoding     :   '',  fail_reason   :   '',
                    ipadress      :   '',  info_detail   :   '' ,
                    info_abbrev   :   '' , country       :   '' ,
                    province      :   '' , city          :   ''
                };
            }
        });
    }

    // 用地理坐标地址进行定位
    function v3ui_location_by_longlatitude(position, othis) {
        $.ajax({
            type: 'GET',
            cache: false,
            url: '//api.map.baidu.com/geocoder/v2/?ak=3rR1T9pmVnO2WUtXfEpjWKL3&location=' + position.coords.latitude + ',' + position.coords.longitude + '&output=json&pois=0',
            dataType: 'jsonp',
            jsonp: 'callback',
            success: function (result) {
                var address_detail = result.result.addressComponent;

                // 显示结果
                $('.v3css_control_text', othis).text(address_detail.city || address_detail.province || address_detail.country);
                $('.v3css_control_icon', othis).removeClass('v3css_icon_location_outline')
                    .addClass('v3css_icon_location cl-ok');

                // 保存结果
                othis.data('location').options.result = {
                    geocoding     :   position.coords.longitude + ',' + position.coords.latitude,
                    fail_reason   :   '',
                    ipadress      :   g_client_ip ,
                    info_detail   :   address_detail ,
                    info_abbrev   :   address_detail.city == address_detail.province ? address_detail.province : address_detail.province + address_detail.city ,
                    country       :   address_detail.country ,
                    province      :   address_detail.province ,
                    city          :   address_detail.city
                };
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                v3ui_location_by_ip(othis)
            }
        });
    }

    $.fn.v3ui_location = function (options, param) {

        if (typeof options == "string") {
            return $.fn.v3ui_location.methods[options](this, param);
        }

        //自动执行初始化函数
        options = options || {};
        return this.each(function () {
            var state = $.data(this, "location");
            if (state) {
                $.extend(state.options, options);
            } else {
                $.data(this, "location", {
                    options: $.extend({}, $.fn.v3ui_location.defaults, $(this).data('options'), $(this).data('location'), options)});
                v3ui_location_init(this);
            }
        });
    };

    $.fn.v3ui_location.methods = {
        val : function(othis){
            $(othis).data('location').options.result.fail_reason = othis.attr('location_fail_reason');
            return $(othis).data('location').options.result;
        }
    };

    $.fn.v3ui_location.defaults = {};
})(jQuery);

(function ($) {
    /*
     视频播放控件
     */

    //初始化
    function v3ui_video_init(container) {
        var othis = $(container);

        // 修改高度
        v3ui_video_resize(container);
        $(window).resize(v3ui_video_resize);

        // 直接播放
        register_on_app_ready(function () {
            v3ui_video_app_ready(container);
        });

        //注册点击播放按钮事件
        var banner = {
            'VIDEO_MP4_URL': $('#video_mp4_url', othis).val(),
            'VIDEO_HLS_URL': $('#video_hls_url', othis).val(),
            'VIDEO_NAME'   : $('#video_name', othis).val(),
            'DURATION': $('#duration', othis).val(),
            'SIZE'   : $('#size', othis).val(),

        };
        $('.v3ui_video_play_img', othis).on('click', function () {
            v3ui_video_full_screen_play(banner);
        });
    }

    function v3ui_video_update(container, options){
        var othis = $(container);
        var banner = options.banner;

        if (banner && banner.URL && banner.URL.indexOf('video://') == 0 ) {
            // app版本大于等于2.7采用原生满屏播放
            //if(banner.SUB_TYPE =='banner'){
            if ((g_browser == 'app' && g_app_version && g_app_version >= 10000) ) {
                //banner视频播放
                if (banner.VIDEO_TYPE == 'banner' ) {
                    // v3ui_video_banner存在修改其值，否则生成
                    if($('.v3ui_video_banner',othis).length > 0){
                        $('.v3ui_video_play_img',othis).attr('src', g_cdn_audio + '/tina/static/audio/play_v.png');
                        $('.v3ui_video_bg_img',othis).attr('lazytype', 'banner').attr('data-original', banner.IMG).css('height', (banner.HEIGHT == '0' || !banner.HEIGHT) ? 'auto' : banner.HEIGHT + 'px');
                    }else{
                        var video_banner = $('<div>').addClass('v3ui_video_banner');
                        var paly_button = $('<div>').addClass('v3ui_video_play_button');
                        $('<img>').addClass('v3ui_video_play_img').attr('src', g_cdn_audio + '/tina/static/audio/play_v.png').appendTo(paly_button);
                        paly_button.appendTo(video_banner);
                        if (banner.VIDEO_TYPE == 'banner') {
                            $('<img>').addClass('v3ui_video_bg_img').attr('lazytype', 'banner').attr('data-original', banner.IMG).css('height', (banner.HEIGHT == '0' || !banner.HEIGHT) ? 'auto' : banner.HEIGHT + 'px').appendTo(video_banner);
                        }
                        video_banner.appendTo(othis);

                        // 修改高度
                        v3ui_video_resize(container);
                        $(window).resize(v3ui_video_resize);

                        // 注册banner图片点击事件
                        $('.v3ui_video_play_img', othis).on(g_clickevent, function () {
                            return v3ui_video_full_screen_play( banner );
                        });
                    }
                    $('.v3ui_video_bg_img',othis).lazyload_image().lazyload('update');
                    // 隐藏普通banner
                    $('.v3ui_video_html5', othis).hide();
                    $('.v3ui_video_banner', othis).show();
                }
            } else {
                // 低版本或其他终端采用HTML5播放，存在修改其值，否则修改其值
                if($('.v3ui_video_html5', othis).length > 0 ){
                    if (banner.VIDEO_TYPE == 'banner') {
                        $('video',othis).attr('poster', banner.IMG)
                    } else {
                        $('video',othis).attr('poster', banner.THUMB_URL)
                    }
                    $('source',othis).attr('src', banner.VIDEO_MP4_URL).attr('type', 'video/mp4')
                }else{
                    var html5 = $('<div>').addClass('v3ui_video_html5');
                    var video = $('<video>').attr('controls', 'controls').attr('preload', 'auto');
                    if (banner.VIDEO_TYPE == 'banner') {
                        video.attr('poster', banner.IMG)
                    } else {
                        video.attr('poster', banner.THUMB_URL)
                    }
                    $('<source>').attr('src', banner.VIDEO_MP4_URL).attr('type', 'video/mp4').appendTo(video);
                    html5.append(video).appendTo(othis);
                }
                // 隐藏普通banner
                $('.v3ui_video_html5', othis).show();
                $('.v3ui_video_banner', othis).hide();
            }
        }
    }
    
    // 重置banner播放按钮位置
    function v3ui_video_resize(container) {
        var othis = $(container);
        //修改高度
        $('.v3ui_video_bg_img').load(function () {
            $('.v3ui_video_play_img' , othis).css('margin-top', $('.v3ui_video_bg_img', othis).height() / 2 - 30);
        });
    }

    // banner视频播放
    function v3ui_video_full_screen_play( banner) {
        register_on_app_ready(function () {
            if(banner.VIDEO_MP4_URL || banner.VIDEO_HLS_URL){
                js_app_send({
                'command': 'videoplay',
                'mp4': banner.VIDEO_MP4_URL,
                'hls': banner.VIDEO_HLS_URL,
                'title': banner.VIDEO_NAME,
                'fullScreen': 'full',
                'auto_play': true,
                'duration'     :   parseInt(banner.DURATION || 0),
                'size'         :   parseInt(banner.SIZE || 0),
            });
            }

        });
    }

    // app版本大于等于2.7采用原生播放视频信息
    function v3ui_video_app_ready(container) {
        var othis = $(container);
        if(g_browser == 'app' && g_app_version >= 10000 ){
            if($('#video_mp4_url',othis).val()){
                g_templates_mode = 'video';
                js_app_send({'command'      :   'notify_play_info' ,
                         'mediatype'    :   'video',
                         'playurl'      :   $('#video_mp4_url',othis).val(),
                         'm3u8url'      :   $('#video_hls_url',othis).val(),
                         'thumburl'     :   $('#thumb_url',othis).val(),
                         'title'        :   $('#video_name',othis).val(),
                         'seektime'     :   0,
                         'auto_play'    :   true,
                         'interrupt'    :   jQuery.parseJSON( $('#interrupt',othis).val()||null),
                         'readsense'    :   $('#readsense',othis).val() == 'True' ,
                         'duration'     :   parseInt($('#duration',othis).val() || 0),
                         'size'         :   parseInt($('#size',othis).val() || 0),
                        });
            }

        }
    };

    $.fn.v3ui_video = function (options) {
        if (typeof options == 'string') {
            return $.fn.v3ui_video.methods[options].apply(this, arguments);
        }

        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'video');
            if (state) {
                $.extend(state.options, options);
            } else {
                $.data(this, 'video', {options: $.extend({}, $.fn.v3ui_video.defaults, options, $(this).data('video'))});
                v3ui_video_init(this);
            }
        });
    };

    $.fn.v3ui_video.defaults = {};

    //可以调用和字符串相符的函数
    $.fn.v3ui_video.methods = {
        update: function (obj, options) {
            v3ui_video_update($(this), options);
        }
    }

})(jQuery);

(function ($) {
    /*
     音频播放控件
     */

    //初始化
    function v3ui_audio_init(container) {
        var othis = $(container);

        //var new_element=document.createElement("script");
        //new_element.setAttribute("type","text/javascript");
        //new_element.setAttribute("src",g_cdn_audio + "/static/background-blur/js/background-blur.js");
        //document.head.appendChild(new_element);
        
        if(g_browser == 'app' ){
            // 直接播放
            register_on_app_ready(function () {
                v3ui_audio_app_ready(container);
            });
        }else{
            $('.audio_player').backgroundBlur({
                imageURL: $('#thumb_url').val(), // URL to the image that will be used for blurring
                blurAmount: 10, // Amount of blur (higher amount degrades browser performance)
                imageClass: 'avatar-blur' // CSS class that will be applied to the image and to the SVG element,
            });

            var audio_player = $('audio',othis)[0];

            // 绑定HTML5播放器的事件
            $('audio',othis).bind('durationchange', function () {
                $('.audio_player_duration',othis).html(fmt_time(audio_player.duration));
            });

            $('audio',othis).bind('timeupdate', function () {
                $('.audio_player_curpos',othis).html(fmt_time(audio_player.currentTime));

                // 计算提示条
                posbar = $('.audio_player_posbar',othis).parent().width() * audio_player.currentTime / audio_player.duration;
                $('.audio_player_posbar',othis).css('width', posbar + 'px');
                $('.audio_player_posblock',othis).css('left', (posbar - $('.audio_player_posblock',othis).width()) + 'px');
            });

            $('.audio_player_clickbar',othis).bind(g_clickevent, function (e) {
                if (g_clickevent == 'touchstart')
                    offsetX = e.originalEvent.targetTouches[0].pageX - 10;
                else
                    offsetX = e.offsetX;

                if (audio_player.played) {
                    new_pos = offsetX * audio_player.duration / $('.audio_player_progressbar',othis).width();
                    if (new_pos > audio_player.duration)
                        new_pos = audio_player.duration;
                    audio_player.currentTime = new_pos;

                    if (audio_player.paused)
                        audio_player.play();
                }

            });

            $('audio',othis).bind('play', function () {
                $('.audio_play_button_img',othis)[0].src = g_cdn_audio + '/tina/static/app/uc/uc_pause.png';
            });

            $('audio',othis).bind('pause', function () {
                $('.audio_play_button_img',othis)[0].src = g_cdn_audio + '/tina/static/app/uc/uc_play.png';
            });

            $('audio',othis).bind('ended', function () {
                $('.audio_play_button_img',othis)[0].src = g_cdn_audio + '/tina/static/app/uc/uc_play.png';
            });

            $('.audio_play_button_img',othis).click(function () {
                if (audio_player.paused) {
                    audio_player.play();
                }
                else {
                    audio_player.pause();
                }
            });
        }
    }

    // app版本大于等于2.8采用原生播放视频信息 #}
    function v3ui_audio_app_ready(){
        if($('#audio_url').val()){
            g_templates_mode = 'audio';
            js_app_send({'command'      :   'notify_play_info' ,
                         'mediatype'    :   'audio', //默认video
                         'playurl'      :   $('#audio_url').val(),
                         'thumburl'     :   $('#thumb_url').val(),
                         'title'        :   $('#audio_name').val(),
                         'seektime'     :   0,
                         'auto_play'    :   true
                        });
        }
    }

    $.fn.v3ui_audio = function (options) {
        if (typeof options == 'string') {
            return $.fn.v3ui_audio.methods[options].apply(this, arguments);
        }

        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'audio');
            if (state) {
                $.extend(state.options, options);
            } else {
                $.data(this, 'audio', {options: $.extend({}, $.fn.v3ui_audio.defaults, options, $(this).data('audio'))});
                v3ui_audio_init(this);
            }
        });
    };

    $.fn.v3ui_audio.defaults = {};

    //可以调用和字符串相符的函数
    $.fn.v3ui_audio.methods = {}

})(jQuery);

(function ($) {
    /*
     banner控件
     */

    //初始化
    function v3ui_banner_init(container) {
        var othis = $(container);
        var banner = othis.data('banner').options;

        v3ui_banner_update(container,banner);
    }

    // 修改banner信息
    function v3ui_banner_update(container,banner) {
        var othis = $(container);
        var banner = banner;

        if (banner.URL && banner.URL.indexOf('video://') == 0) {
            $('.v3ui_video').v3ui_video('update', {banner:banner});
            $('.v3ui_video', othis).show();
            $('.banner_img', othis).hide();
        } else {
            $('.banner_url', othis).attr('href', banner.URL);
            $('.banner_img', othis).attr('lazytype', 'banner').attr('data-original', smart_cache(banner.IMG)).css('height', (banner.HEIGHT == '0' || !banner.HEIGHT) ? 'auto' : banner.HEIGHT + 'px').lazyload_image().lazyload('update');
            $('.v3ui_video', othis).hide();
            $('.banner_img', othis).show();
        }

        // banner嵌入的文字
        if (banner.TEXT)
            $('.banner_info', othis).html(banner.TEXT).closest('.banner_txt').show();
        else
            $('.banner_info', othis).closest('.banner_txt').hide();

        // banner扩展文字
        if (banner.EXTRATEXT)
            $('.banner_extra', othis).html(banner.EXTRATEXT).show();
        else
            $('.banner_extra', othis).hide();
    }

    $.fn.v3ui_banner = function (options) {
        if (typeof options == 'string') {
            return $.fn.v3ui_banner.methods[options].apply(this, arguments);
        }

        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'banner');
            if (state) {
                $.extend(state.options, options);
            } else {
                $.data(this, 'banner', {options: $.extend({}, $.fn.v3ui_video.defaults, options, $(this).data('banner'))});
                v3ui_banner_init(this);
            }
        });
    };

    $.fn.v3ui_banner.defaults = {};

    //可以调用和字符串相符的函数
    $.fn.v3ui_banner.methods = {
        update: function (obj, options) {
            v3ui_banner_update($(this), options.banner);
        }
    };

})(jQuery);

(function ($) {
    /*
     微店操作控件
     */

    //初始化
    function v3ui_shop_init(container) {
        var othis = $(container);

        // 添加购物车
        $('.addcart', othis).bind('click', function (e) {
            // 取页面信息
            v3ui_shop_addcart(container)
        });

        // 立即购买和免费体验都是将物品加入购物车，然后跳转到购物车
        // 购物车分为两种模式进入，下载体验版进去，和立即购买进去
        $('.experience,.buynow', othis).bind('click', function (e) {
            var type = $(e.target).attr('id');
            v3ui_shop_buynow(container, type);
        });
    }

    // 加入购物车
    function v3ui_shop_addcart(container) {
        var othis = $(container);
        var product_id = $('#pid', othis).val();
        var supplier_id = $('#supplier_id', othis).val();
        var shop = othis.data('shop').options;

        if (shop.cartlen > 50) {
            $.alert('超过购物车上限，请清除不需要的商品！');
            return false;
        }

        $.ajax({
            cache: false,
            async: false,
            type: 'GET',
            url: '/pay/addtocart',
            data: {
                'product_id': product_id,
                'supplier_id': supplier_id,
                'sku_id': shop.sku_id,
                'quantity': shop.quantity
            },
            dataType: 'json',
            success: function (data) {
                if (data.cartlength > 0) {
                    $('.carttip', othis).html(data.cartlength);
                    $('.carttip', othis).show();
                    $.confirm('已经添加到购物车','人教微研友情提醒',  ['再逛逛', '去结算'], function (arg, defer) {
                        if (arg == '去结算') {
                            window.location = '/pay/cart';
                        }
                    });
                }
            },
            error: function (error) {
                $.v3ui_toast('系统发生意外错误，请稍后重试');
            }
        });
        return false;
    };

    // 立即结算
    function v3ui_shop_buynow(container, type) {
        var othis = $(container);
        var shop = othis.data('shop').options;

        if ($('#price',othis).val() == 0 && type =='experience'){
            type = 'buynow|free';
        }

        var product_id = $('#pid', othis).val();
        var supplier_id = $('#supplier_id', othis).val();

        if (g_browser == 'app') {
            js_app_send({
                'command': 'openview',
                'region_name': 'popup',
                'view_name': 'order_confirm',
                'url': g_site + '/pay/buy_now?sku_id=' + shop.sku_id + "&quantity=" + shop.quantity + '&type=' + type
            });
            js_app_send({
                'command': 'closeview',
                'view_name': ''
            });
        }
        else {
            window.location.href = '/pay/buy_now?sku_id=' + shop.sku_id + "&quantity=" + shop.quantity + '&type=' + type;
        }

        return false;
    }

    $.fn.v3ui_shop = function (options) {
        if (typeof options == 'string') {
            return $.fn.v3ui_shop.methods[options].apply(this, arguments);
        }

        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'shop');
            if (state) {
                $.extend(state.options, options);
            } else {
                $.data(this, 'shop', {options: $.extend({}, $.fn.v3ui_shop.defaults, options, $(this).data('shop'))});
                v3ui_shop_init(this);
            }
        });
    };

    $.fn.v3ui_shop.defaults = {
        quantity: '1',
        sku_id: 1,
        cartlen: 1
    };

    //可以调用和字符串相符的函数
    $.fn.v3ui_shop.methods = {}

})(jQuery);

(function ($) {
    /**
     * 图片上传 控件
     */

    function v3ui_image_upload_update(target){
        var othis           = $(target);
        var options         = othis.data('v3ui_image_upload').options;
        othis.find('.nbiu_inrect').width(options.width).css({'line-height': options.height + 'px'});
        othis.attr('max_upload', options.max_upload);

        $.data(othis[0] , 'v3ui_image_upload').options.on_valid_change(0, othis.attr('max_upload'));
        othis.find('.nbiu_tip').html('还可以上传' + othis.attr('max_upload') + '张照片哟~');
    }

    function v3ui_image_upload_init(target){
        var othis           = $(target);
        var options         = othis.data('v3ui_image_upload').options;

        // 显示提示
        if(othis.attr('image_tip')){
            $('.image_tip', othis).text(othis.attr('image_tip').trim());
        }

        othis.attr('max_upload', options.max_upload);

        // 按照指定的窗口大小设置各元素
        othis.find('.nbiu_inrect').width(options.width).css({'line-height': options.height + 'px'});

        // 如果nbiu_form的数量大于1，说明是初始化过的，就不需要再绑定事件了
        // 因为默认里面包含了一个隐藏的FORM，所有新增出来的上传控件都是从这个复制出来的
        if (othis.find('.nbiu_form').length == 1){

            if (g_app_version >= 10000 ){
                othis.on('click' , '.nbiu_imginput' , v3ui_image_upload_app );
            }else{
                othis.on('change' , '.nbiu_imginput' , v3ui_image_upload_selected);
            }

            othis.on('click' , '.nbiu_cancel' , v3ui_image_upload_cancel);
	        othis.find('.nbiu_form').attr('name' , othis.attr('id') + '0').attr('id' , othis.attr('id') + '0');
        }

        //app 自己选择图片上传回调
        register_app_js_handle('on_appcmd_imguploadret', function (message) {
            var obj_form    = $('#'+ message.obj_id);

            // 如果当前对象v3ui_image_upload，则父对象就是自身，否则找出父对象  循环直到找到v3ui_image_upload
            var parent_obj  = obj_form.hasClass('v3ui_image_upload') ? obj_form : obj_form.closest('.v3ui_image_upload')
            if (parent_obj.length > 0){
                parent_obj.v3ui_image_upload('app_image_upload', message);
            }
        });
        
        v3ui_image_upload_new(othis);

        // 根据是否设定了imagelinelimit（每行最小元素数量）动态计算width和height
        // 一旦设定了imagelinelimit，则原来的width和height就成了最大宽度（当然最大不会超过屏幕宽度），新调整比例也遵循width/height
        var width_container = othis.width();

        if (options.imagelinelimit){
            var imagelinelimit  = parseInt(options.imagelinelimit);

            if (imagelinelimit == 1)
                $('.nbiu_form' , othis).css('margin-right' , '0px');

            var delete_space    = $('.nbiu_form' , othis).extend_outer_horizontal() + $('.nbiu_form .nbiu_inrect' , othis).extend_outer_horizontal();
            var width_control   = width_container - delete_space;
            width_control   = Math.min(width_control / imagelinelimit , options.width) - delete_space;
            var height_control  = width_control * options.height / options.width;

            othis.v3ui_image_upload({ width : width_control , height : height_control});
        }
        else{
            // 最大不能超过屏幕宽度
            var delete_space2   = $('.nbiu_form' , othis).extend_outer_horizontal() + $('.nbiu_form .nbiu_inrect' , othis).extend_outer_horizontal();
            var width_control2  = width_container - delete_space2;

            if (options.width > width_control2 - delete_space2){
                $('.nbiu_form' , othis).css('margin-right' , '0px');
                delete_space2 = $('.nbiu_form' , othis).extend_outer_horizontal() + $('.nbiu_form .nbiu_inrect' , othis).extend_outer_horizontal();

                width_control2  = width_container - delete_space2;
                var height_control2  = width_control2 * options.height / options.width;

                othis.v3ui_image_upload({ width : width_control2 , height : height_control2});
            }
        }

        return othis;
    }

    // 点击图片选择窗口右上角的减号，取消图片的选择
    function v3ui_image_upload_cancel(){

        // 寻找最顶层的nbiu_form元素，进行删除
        var parent_obj = $(this).closest('.nbiu_form');

        if (parent_obj.length > 0){
            var new_parent = parent_obj.closest('.v3ui_image_upload');

            parent_obj.remove();

            // 删除之后重新创建新的
            if (new_parent.length > 0){
                v3ui_image_upload_new(new_parent);
            }
        }
        // 阻止冒泡事件
        return false ;
    }

    function v3ui_image_upload_selected(e){
        var theEvent        = window.event || arguments.callee.caller.arguments[0];
        var obj_fileinput   = $(theEvent.srcElement ? theEvent.srcElement : theEvent.target);
        var file_select     = obj_fileinput[0].files[0];

        if (!file_select){
            return;
        }

        var ext     = file_select.name.toUpperCase();
        if(!/\.PNG|\.GIF|\.JPG|\.JPEG$/.test(ext)){
            obj_fileinput.val("");
            return $.alert('目前只支持JPG/PNG/GIF格式！' , true|false);
        }

        // 定位同父元素下的类preview元素
        var obj_image   = obj_fileinput.parent().find('.nbiu_preview');
        var createObj   = window.createObjectURL ? window : window.URL || window.webkitURL;
        var url         = createObj.createObjectURL(file_select);

        obj_image.attr('src', url).show();
        obj_image.parent().find('.nbiu_cancel').show();

        // 寻找最近的v3ui_image_upload元素
        var parent_obj  = obj_fileinput.closest('.v3ui_image_upload');

        if (parent_obj.length > 0){
            v3ui_image_upload_new(parent_obj);
        }

        // 添加选中后回调事件
        var opts = $.data(parent_obj[0], "v3ui_image_upload").options;
        opts.on_upload_select.call(parent_obj[0], parent_obj);
    }

    function v3ui_image_upload_app(){

        var parent_obj  = $(this).closest('.nbiu_form');
        var upload_num  = 1 ;   // 上传图片数

        // app版本大于20600，并且新增操作
        if(g_app_version >= 10000  && !parent_obj.find('.nbiu_preview').attr('src')){
            parent_obj  = parent_obj.closest('.v3ui_image_upload');

            // 判断最多允许上传图片个数
            var max_id          = 0;
            var count_blank     = -1;
            var count_created   = -1;

            parent_obj.find('.nbiu_form').each(function() {
                var this_id     = parseInt($(this).attr('id').substr(parent_obj.attr('id').length));
                max_id          = Math.max(this_id, max_id);
                count_created   += 1;

                if (!$(this).find('.nbiu_preview').attr('src')){
                    count_blank += 1;
                }
            });

            // 如果没有空，且还允许创建，才创建新的上传空间
            var max_upload  = parseInt(parent_obj.attr('max_upload'));
            upload_num      = max_upload + count_blank - count_created;
        }

        if (parent_obj.length > 0){
            js_app_send({
                'command'   : 'imgupload',
                'obj_id'    : parent_obj.attr('id'),
                'max_upload': upload_num,
                'width'     : parseInt($(this).closest('.nbiu_inrect').width()),
                'height'    : parseInt($(this).closest('.nbiu_inrect').height()),
                'url'       : g_site + $(this).closest('.nbiu_form').attr('action')
            });
        }
        return false;
    }

    // 触发指定ID的图片上传FORM提交，并在完成后回调callback函数
    // callback为function(result , form_id , callagrs)，参数指示提交是否成功
    // 返回true或false，表示提交是否成功（form_id合法，且图片文件已经选择）
    function v3ui_image_upload_submit(obj_form , callback , callargs){

        obj_form.ajaxSubmit({
            dataType    : 'JSON',

            // 提交开始的时候将进度条显示出来
            beforeSend  : function(ev){
                obj_form.find('.probar').show();
                $('.g_probar').show();
                $('.g_proindicator').css('width' , '0px');
            },

            // 显示上传的进度指示
            uploadProgress: function(event , position , total , percent){
                // $('#p').html(position + ',' + total + ',' + percent)
                obj_form.find('.proindicator').css('width' , (percent * obj_form.find('.probar').width() / 100) + 'px');
                $('.g_proindicator').css('width' , (percent * $('.g_probar').width() / 100) + 'px');
            },

            // 失败以后隐藏进度条，调用回调函数，指示失败
            error: function(){
                obj_form.find('.probar').hide();
                $('.g_probar').hide();

                callback(false , obj_form , callargs , null);
            },

            // 提交成功以后隐藏进度条，调用回调函数，指示成功
            success: function(data){
                obj_form.find('.probar').hide();
                $('.g_probar').hide();

                if (data.retcode == 'SUCC')
                    obj_form.attr('fileupload' , data.imagefile);

                callback(true , obj_form , callargs , data);
            }
        });
        return true;
    }

    // 创建一个新的文件上传选择器窗口
    function v3ui_image_upload_new(othis){
        // 找到当前已经存在的那个最大的文件选择form的ID，统计有多少空的
        // 特别提醒：因为有个隐藏的供复制的空间，因此count_blank和count_created都从-1开始计算
        var max_id        = 0;
        var count_blank   = -1;
        var count_created = -1;

        othis.find('.nbiu_form').each(function(){
            var this_id     = parseInt($(this).attr('id').substr(othis.attr('id').length));
            max_id          = Math.max(this_id , max_id);
            count_created   += 1;

            if (!$(this).find('.nbiu_preview').attr('src')){
                count_blank += 1;
            }
        });

        // 如果没有空，且还允许创建，才创建新的上传空间
        var max_upload = parseInt(othis.attr('max_upload'));

        if (!count_blank && count_created < max_upload){
            // 创建新的文件选择器
            var obj_new = othis.find("#" + othis.attr('id') + '0').clone();
            obj_new.attr('id' , othis.attr('id') + (max_id + 1)).attr('name' , othis.attr('id') + (max_id + 1));
            obj_new.appendTo(othis.find('.nbiu_container'));
            obj_new.css('display' , obj_new.find('>div').css('display'));
        }

        if (max_upload > count_created)
            othis.find('.nbiu_tip').html('还可以上传' + (max_upload - (count_created - count_blank)) + '张照片哟~');
        else
            othis.find('.nbiu_tip').html('你最多允许上传' + max_upload + '张照片哦~');

        // 输出可以上传的图片的数量
        $.data(othis[0] , 'v3ui_image_upload').options.on_valid_change((count_created - count_blank) , max_upload);

        // 如果有显示的取消按钮，认为是有选择图片，将提示字隐藏
        //if((count_created - count_blank) != 0){
        //    $('.image_tip', othis).css('visibility', 'hidden');
        //}else{
        //    if(othis.attr('image_tip')) {
        //        $('.image_tip', othis).css('visibility', 'inherit');
        //    }else{
        //        $('.image_tip', othis).css('visibility', 'hidden');
        //    }
        //}
    }

    $.fn.v3ui_image_upload = function (options) {
        if (typeof options == 'string') {
            return $.fn.v3ui_image_upload.methods[options].apply(this, arguments);
        }
        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'v3ui_image_upload');
            if(state){
                $.extend(state.options, options);
                v3ui_image_upload_update(this)
            }else{
                $.data(this, 'v3ui_image_upload', {options: $.extend({}, $.fn.v3ui_image_upload.defaults, $(this).data('options'), $(this).data('image_upload'))});
                v3ui_image_upload_init(this);
            }
        });
    };

    $.fn.v3ui_image_upload.defaults = {
        width           : 70,
        height          : 70,
        max_upload      : 4,
        on_valid_change : function(){},
        on_upload_select: function(){}
    };

    $.fn.v3ui_image_upload.methods  = {
        forms: function(){
            // 请求所有可以提交的form对象和提交函数
            // 对于v3ui_image_upload对象进行图片上传提交的方式应该是
            // imgforms = $('#XXX').v3ui_image_upload('forms')
            // for(index = 0 ; index < imgforms[0].length ; index ++){
            //    list_selected.push([imgforms[0][index] , imgforms[1] , 'TIP ....'])
            var list_form = [];

            this.each(function(){
                $(this).find('.nbiu_form').each(function(){
                    var obj_form = $(this);

                    // 检测该form包含的图片文件字段是否已经选择
                    if (obj_form.find('.nbiu_imginput')[0].files.length)
                        list_form.push(obj_form);
                });
            });
            return [list_form , v3ui_image_upload_submit];
        },

        val: function(){
            // 请求所有已提交form对象的服务器文件名
            var list_files  = [];
            this.each(function(){

                $(this).find('.nbiu_form').each(function(){
                    var obj_form = $(this);

                    if (obj_form.attr('fileupload'))
                        list_files.push(obj_form.attr('fileupload'));
                });
            });
            return list_files;
        },

        app_image_upload: function(othis, uploadObj){

            var obj_form    = $('#' + uploadObj.obj_id);
            var form_id     = uploadObj.obj_id;

            // 如果当前对象v3ui_image_upload，找出除模板以外的空图片nbiu_form对象id
            if (obj_form.hasClass('v3ui_image_upload')) {
                obj_form.find('.nbiu_form').each(function(){
                    var this_id = parseInt($(this).attr('id').substr(obj_form.attr('id').length));
                    if (this_id != 0 && !$(this).find('.nbiu_preview').attr('src')){
                        form_id = $(this).attr('id');
                        return false;
                    }
                });
            }

            obj_form        =  $(this).find('#' + form_id);
            var obj_image   =  obj_form.find('.nbiu_preview');
            obj_image.attr('src'       , uploadObj.real_url).show().siblings('.nbiu_cancel').show();

            obj_form.attr('fileupload' , uploadObj.img_name);
            obj_form.attr('filesource' , uploadObj.filesource || '');
            obj_form.attr('take_time'  , uploadObj.take_time || '');
            obj_form.attr('gpsinfo'    , uploadObj.gpsinfo != 'null,null' ? uploadObj.gpsinfo : '');
            obj_form.attr('device'     , uploadObj.device || '');
            v3ui_image_upload_new($(this));
        }
    }

})(jQuery);

(function ($) {
    /*
     * 支持V3SECTION的布局函数
     */
    function v3ui_section_layout(target , force_rebuild){
        var ocontainer  = $('.v3items' , target);
        if (!ocontainer.length)
            return;

        var oitems = force_rebuild ? $('.v3item' , ocontainer) : $('.v3item:not(.layoutdone)' , ocontainer);
        if (!oitems.length)
            return;

        var state = target.data('options');
        var limit_items = state.limit_items || 2;
        var max_width   = state.max_width || 320;
        var x_space     = state.x_space || 10;
        var oitems_done = force_rebuild ? 0 : $('.v3item.layoutdone' , ocontainer).length;

        var width_container = ocontainer.width();

        // 计算按照最大宽度能放几个元素
        var items_count_inline = Math.max(Math.floor((width_container + x_space) / max_width) , limit_items);
        var width_item = Math.floor((width_container + x_space)/ items_count_inline - x_space);
        state.count_per_line = items_count_inline;

        oitems.each(function(){
            var othis = $(this);
            oitems_done += 1;

            othis.width(width_item - othis.extend_inner_horizontal()).addClass('layoutdone')
                .css('max-width' , 'none').css('margin-right' , (oitems_done % items_count_inline ? x_space : 0) + 'px');

            if (!othis.hasClass('v3section_more_area'))
                othis.css('display' , 'inline-block');

            othis.parent().clear_text_space();
        });

        // 删除所有的DIV之间的空格
        ocontainer.clear_text_space();

        if (!ocontainer.hasClass('clear_after'))
            ocontainer.addClass('clear_after');
    }

    $.fn.v3ui_section_layout = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_section_layout.methods ? $.fn.v3ui_section_layout.methods[options](this, param) : null;

        // 全局为v3ui_section_layout注册windows.resize事件
        $.global_run_once('register_v3ui_section_layout_resize' , function(){
            $(window).resize(function(){
                $('.v3ui_section_layout').v3ui_section_layout('layout' , true);
            });
        });

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'section_layout');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'section_layout', {
                    options: $.extend({}, $.fn.v3ui_section_layout.defaults, options)
                });
            }
            v3ui_section_layout($(this));
        });
    };

    $.fn.v3ui_section_layout.methods   = {
        layout  :   function(target , param){
                        target.each(function(){
                            v3ui_section_layout($(this) , param);
                        });
                    }
    }
})(jQuery);

(function ($) {
    /*
     * 支持V3SECTION的布局函数
     */
    function v3ui_autolayout(target , force_rebuild){
        var state = target.data('options');
        var tag_name    = state && state.tag_name ? state.tag_name : 'img';
        var limit_items = state && state.limit_items ? state.limit_items : 3;
        var max_width   = state && state.max_width ? state.max_width : 240;
        var x_space     = state && state.x_space ? state.x_space : 3;
        var y_space     = state && state.y_space ? state.y_space : 3;
        
        // var width_container = target.width();
        var width_container = $(window).width() - 10;
        
        // var oitems  = $(tag_name + ':visible' , target);
        var oitems  = $(tag_name, target);

        if (!oitems.length)
            return;
        //else if (oitems.length < limit_items)
        //    limit_items = oitems.length;

        // 计算按照最大宽度能放几个元素
        var items_count_inline = Math.max(Math.floor((width_container + x_space) / max_width) , limit_items);
        var width_item = Math.floor((width_container + x_space)/ items_count_inline - x_space);
        max_width = Math.max(max_width , width_item);

        var oitems_done = 0;
        oitems.each(function(){
            var othis = $(this);
            oitems_done += 1;

            othis.width(width_item - othis.extend_inner_horizontal())
                .css('max-width' , max_width + 'px').css('display' , 'inline-block')
                .css('margin-bottom' , y_space + 'px')
                .css('margin-right' , (oitems_done % items_count_inline ? x_space : 0) + 'px')

            othis.parent().clear_text_space();
        });

        // 删除所有的DIV之间的空格
        target.clear_text_space();

        // 隐藏装载中的提示
        if (!target.hasClass('clear_after'))
            target.addClass('clear_after');
    }

    $.fn.v3ui_autolayout = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_autolayout.methods ? $.fn.v3ui_autolayout.methods[options](this, param) : null;

        // 全局为v3ui_section_layout注册windows.resize事件
        $.global_run_once('register_v3ui_autolayout_resize' , function(){
            $(window).resize(function(){
                $('.v3ui_autolayout').v3ui_autolayout('layout' , true);
            });
        });

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'autolayout');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'autolayout', {
                    options: $.extend({}, $.fn.v3ui_autolayout.defaults, options)
                });
            }
            v3ui_autolayout($(this));
        });
    };

    $.fn.v3ui_autolayout.methods   = {
        layout  :   function(target , param){
                        target.each(function(){
                            v3ui_autolayout($(this) , param);
                        });
                    }
    }

    $.fn.v3ui_autolayout.defaults  = {
    }
})(jQuery);

(function ($) {
    /*
     * 支持V3SECTION的布局函数
     */
    function v3ui_app_menucontrol(target){
        // APP 3.0版本以上，将该菜单项设置为APP右上角菜单入口
        if (g_app_version < 10000)
            return;

        var menu_temp = { id : target.attr('menuid') , name : $.trim(target.html()) , type : "1" , foregroundcolor :  "#FFFFFF" , backgroundcolor : "#FFFFFF" , 'strokeStyle' : !target.attr("hide-bold"), action : "show"  };

        if (g_app_version >= 10000){
            menu_temp.image = $.trim(target.attr('image_text'))
        }



        if(g_app_version >= 10000 ){
            //menu_temp.strokeStyle = false
            //menu_temp.backgroundcolor = '#18B4ED';
            //delete  menu_temp.foregroundcolor;
            if (!target.attr("hide-bold")){
                menu_temp.backgroundcolor = target.attr("bold-color") ? target.attr("bold-color") : '#333333';
            } else {
                delete menu_temp.backgroundcolor;
            }
            menu_temp.foregroundcolor = target.attr("font-color") ? target.attr("font-color") : '#333333';
        }

        register_on_app_ready(function () {
                jsapp_command('menucontrol' , 'menu_action' ,
                [   { id : "10010" , name : "刷新" , action : "hide" }, menu_temp
                    //{ id : "10011" , name : "分享" , action : "hide" } ,
                ]);
        });

        target.hide();
    }

    $.fn.v3ui_app_menucontrol = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_app_menucontrol.methods ? $.fn.v3ui_app_menucontrol.methods[options](this, param) : null;

        // 全局为v3ui_app_menucontrol注册app_js事件
        $.global_run_once('register_v3ui_app_menucontrol_handle' , function(){
            register_app_js_handle('on_appcmd_menuclicked' , function(cmd_data){
                if($('.v3ui_app_menucontrol').attr('doing') == 'true'){
                    return false;
                }

                var global_stat = $.global_namespace();
                if(global_stat.lockscreen){
                    return false;
                }

                $('.v3ui_app_menucontrol').attr('doing', 'true');
                $('.v3ui_app_menucontrol[menuid=' + cmd_data.id + ']').click();
                $('.v3ui_app_menucontrol').removeAttr('doing');
            });

        });

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'app_menucontrol');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'app_menucontrol', {
                    options: $.extend({}, $.fn.v3ui_app_menucontrol.defaults, options)
                });
            }
            v3ui_app_menucontrol($(this));
        });
    };

    $.fn.v3ui_app_menucontrol.methods   = {
    }
})(jQuery);


(function ($) {
    /*
     * 支持V3SECTION的布局函数
     */
    function v3ui_app_menucontrol_all(target){
        // APP 3.0版本以上，将该菜单项设置为APP右上角菜单入口
        // if (g_app_version < 10000)
        //     return;

        var menu_temp = { 
                id      : target.attr('menuid') , 
                name    : $.trim(target.html()) ,
                type    : "1" , 
                foregroundcolor : "#FFFFFF" , 
                backgroundcolor : "#FFFFFF" , 
                strokeStyle     : !target.attr("hide-bold"), action : "show",
                image   : $.trim(target.attr('image_text'))
        };

        if (!target.attr("hide-bold")){
            menu_temp.backgroundcolor = target.attr("bold-color") ? target.attr("bold-color") : '#333333';
        } else {
            delete menu_temp.backgroundcolor;
        }
        menu_temp.foregroundcolor = target.attr("font-color") ? target.attr("font-color") : '#333333';
        g_multi_menu.push(menu_temp)
        // return menu_temp
        // register_on_app_ready(function () {
        //     jsapp_command('menucontrol' , 'menu_action' ,
        //         [   
        //             { id : "10010" , name : "刷新" , action : "hide" }, menu_temp
        //         ]);
        // });

        target.hide();
    }

    $.fn.v3ui_app_menucontrol_all = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_app_menucontrol_all.methods ? $.fn.v3ui_app_menucontrol_all.methods[options](this, param) : null;

        // 全局为v3ui_app_menucontrol注册app_js事件
        $.global_run_once('register_v3ui_app_menucontrol_handle' , function(){
            register_app_js_handle('on_appcmd_menuclicked' , function(cmd_data){
                if($('.v3ui_app_menucontrol_all').attr('doing') == 'true'){
                    return false;
                }

                var global_stat = $.global_namespace();
                if(global_stat.lockscreen){
                    return false;
                }

                $('.v3ui_app_menucontrol_all').attr('doing', 'true');
                $('.v3ui_app_menucontrol_all[menuid=' + cmd_data.id + ']').click();
                $('.v3ui_app_menucontrol_all').removeAttr('doing');
            });

        });

        options = options || {};
        var menu_list = []
        return this.each(function(){
            var state = $.data(this, 'app_menucontrol');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'app_menucontrol', {
                    options: $.extend({}, $.fn.v3ui_app_menucontrol_all.defaults, options)
                });
            }
            v3ui_app_menucontrol_all($(this));
        });
    };

    $.fn.v3ui_app_menucontrol_all.methods   = {
    }

})(jQuery);



(function ($){
    /* 文本控件 */

    // 统计输入字符数
    function v3ui_richdiv_stat_input(){

        // 文本字符数
        var stat_val    = $(this).text().length;

        // emotion数量
        stat_val        += $(this).find('img').length;

        $(this).data('v3ui_richdiv').options.on_stat_count(stat_val);
        $(this).v3ui_richdiv('active' , stat_val);
    }

    function v3ui_richdiv_init(options){
        $(this).attr('contenteditable', true);
        options.max_emotion_tip  = $(this).attr('max_emotion_tip') || options.max_emotion_tip;

        // 监控实时输入字符数量
        $(this).bind('input propertychange', v3ui_richdiv_stat_input);
    }

    $.fn.v3ui_richdiv = function(options, param){
        if (typeof(options) == 'string'){
            return options in $.fn.v3ui_richdiv.methods ? $.fn.v3ui_richdiv.methods[options](this, param) : null;
        }

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'v3ui_richdiv');
            if (state){
                $.extend(state.options, options);
            } else {
                $.data(this, 'v3ui_richdiv', {options: $.extend({},  $.fn.v3ui_richdiv.defaults, $(this).data('options'), options)});
                v3ui_richdiv_init.call(this, $.data(this, 'v3ui_richdiv').options);
            }
        });
    };

    $.fn.v3ui_richdiv.methods   = {
        add_emotion     : function(othis, html){
            //var max_emotion     = othis.data("v3ui_richdiv").options.max_emotion;
            //var max_emotion_tip = $(othis.data("v3ui_richdiv").options.max_emotion_tip);
            //
            //if(max_emotion != -1){
            //    var count_emotion_exists   = othis.find('img.emotion').length;
            //    if(count_emotion_exists >= max_emotion){
            //        if(max_emotion_tip.length)
            //            max_emotion_tip.fadeout_after_duration('亲，为了节省系统资源，每次发表最多使用' + max_emotion + '个动画表情！');
            //        return false;
            //    }
            //}

            othis.append(html);

            // 统计字符数
            v3ui_richdiv_stat_input.call(othis);
        },

        backspace       : function(othis){
            // 对指定容器的回退操作，
            // 如果最后一个Node元素为标签元素，则remove操作，否则截取最后一个元素返回

            if(othis.get(0).childNodes.length > 0){
                var lastChildNode = othis.get(0).lastChild;
                if(lastChildNode.nodeType == 3){
                    // 文本字符串，去掉最后一个字符
                    if(othis.html().endWith('&nbsp;')){
                        othis.html(othis.html().slice(0,-6));
                    }else{
                        othis.html(othis.html().slice(0,-1));
                    }
                }else{
                    $(lastChildNode).remove()
                }
            }

            // 统计字符数
            v3ui_richdiv_stat_input.call(othis);
            return true;
        },

        val         : function(target){
            return target.html();
        },
        html        : function(target , content){
            target.html(content);
            v3ui_richdiv_stat_input.call(target);
        },
        active      :   function(target){
                            var text_tip = target.attr('text_tip');
                            if (!text_tip)
                                return;

                            var obj_text_tip = $('.richdiv_text_tip' , target.parent());
                            if (!obj_text_tip.length)
                                obj_text_tip = $('<div>').addClass('richdiv_text_tip cl-tip').html(text_tip).appendTo(target.parent());

                            var position = target.position();
                            obj_text_tip.css('left' , (position.left + 5) + 'px').css('top' , (position.top + 5) + 'px');
                            target.html() ? obj_text_tip.hide() : obj_text_tip.show();
                            obj_text_tip.click(function(){target.focus()});
                        }
    };

    $.fn.v3ui_richdiv.defaults  = {
        max_emotion         : 6,                    // 单次上传最大的表情数量
        max_emotion_tip     : '',                   // 最大表情数提示
        on_stat_count       : function(data){}      // 统计输入数量
    };

})(jQuery);

(function ($){
    /* 表情控件 */

    function v3ui_emotion_rect_click(){
        // 寻找最顶层的nbrichdiv元素，进行删除
        var options     = $(this).closest('.v3ui_emotion').data('v3ui_emotion').options;

        var ex = parseInt($(this).attr('ex'));
        var ey = parseInt($(this).attr('ey'));

        if (ex == '6' && ey == '2'){
            options.onSelect({type: 'backspace'});
            return false;
        }

        var url_img = $(this).parent().find('.emotion_collection').attr('src').split('.').slice(0 , -1).join('.') + '/' + ex + '_' + ey + '.gif';
        var img_obj = $('<img>').attr('src' , url_img).addClass('emotion');

        options.onSelect({type: 'add_emotion', object : img_obj});

        // 尝试让获取焦点的元素失去焦点，用来屏蔽键盘输入法
        document.activeElement.blur();
        return false;
    }

    // 初始化表情选择器
    function v3ui_emotion_slider_init(othis){
        //// 确定表情图片的最大高度，表情源图片是624*234
        var obj_emotion_container   = othis.find('.nbrd_emotion');
        obj_emotion_container.show();

        // 确定表情图片的最大高度，表情源图片是624*234
        // var width_container         = obj_emotion_container.width();
        var width_container         = $(window).width() - 20;
        var width_emotion           = Math.min(width_container , 624);
        var height_emotion          = width_emotion * 234 / 624;

        // othis.find('.touchslider').css('height' , (height_emotion + othis.find('.touchslider-nav').height()) + 'px');
        othis.find('.touchslider').css('height' , (height_emotion + 16) + 'px');
        othis.find('.touchslider-viewport').css('height' , height_emotion + 'px');
        othis.find('.touchslider-item').css('width' , width_container + 'px');
        othis.find('.touchslider-item').css('height' , height_emotion + 'px');
        othis.find(".touchslider").touchSlider({ mouseTouch: true });

        var left_img    = (width_container - width_emotion)/2;
        var width_img   = width_emotion / 7;
        var height_img  = height_emotion / 3;

        othis.find('.touchslider-item').each(function(){
            var obj_this  = $(this);
            for (var x = 0; x < 7 ; x ++)
                for (var y = 0 ; y < 3 ; y++){
                    $('<div>').css({
                            'position'  : 'absolute',
                            'width'     : width_img + 'px',
                            'height'    : height_img + 'px',
                            'left'      : (x * width_img + left_img) + 'px',
                            'top'       : (y * height_img) + 'px',
                            'border'    : '0px solid black'
                        })
                        .addClass('emotion_a')
                        .attr({
                            'ex'    : x,
                            'ey'    : y,
                            'href'  : '#'
                        })
                        .bind('click' , v3ui_emotion_rect_click)
                        .appendTo(obj_this);
                }
        });
    }

    function v3ui_emotion_init(options){
        var othis           = $(this);
        var nbrd_emotion    = $('<div class="nbrd_emotion">');
        var touchslider     = $('<div class="touchslider v3css_overlay_touchmove" touchmove="left,right">');
        var viewport        = $('<div class="touchslider-viewport" style="overflow:hidden;">');
        var navigator       = $('<div class="touchslider-nav">');

        var wrap_div        = $('<div>');
        $.each(options.face_package.default, function(index, value){
            var touch_items     = $('<div class="touchslider-item" style="text-align:center;">');
            touch_items.append($('<img class="emotion_collection" style="max-width:100%;max-height:100%" src="'+ g_cdn + value +'">'));
            wrap_div.append(touch_items);
            navigator.append($('<a class="touchslider-nav-item">'));
        });

        $('.touchslider-nav-item:first', navigator).addClass('touchslider-nav-item-current');
        wrap_div.appendTo(viewport);
        viewport.appendTo(touchslider);
        navigator.appendTo(touchslider);
        touchslider.appendTo(nbrd_emotion);
        nbrd_emotion.appendTo(othis);

        v3ui_emotion_slider_init(othis);
    }

    $.fn.v3ui_emotion = function(options, param){
        if (typeof(options) == 'string'){
            return options in $.fn.v3ui_emotion.methods ? $.fn.v3ui_emotion.methods[options](this, param) : null;
        }

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'v3ui_emotion');
            if (state){
                $.extend(state.options, options);
            } else {
                $.data(this, 'v3ui_emotion', {options: $.extend({},  $.fn.v3ui_emotion.defaults, $(this).data('options'), options)});
                v3ui_emotion_init.call(this, $.data(this, 'v3ui_emotion').options);
            }
        });
    };

    $.fn.v3ui_emotion.methods   = {};

    $.fn.v3ui_emotion.defaults  = {
        max_face        :   6,                  // 单次上传最大的表情数量
        max_width       :   624,                // 最大宽度624
        max_height      :   234,                // 最大高度234
        face_package    :   {                   // 表情包，默认表情包
            default:  [
                '/static/e/e1.png' ,
                '/static/e/e2.png' ,
                '/static/e/e3.png' ,
                '/static/e/e4.png' ,
                '/static/e/e5.png'
            ]
        },
        onSelect        :  function(){}
    };
})(jQuery);

(function ($){

    function v3ui_switch_init(){
        /*
            DOM 结构：
                <div class="v3ui v3ui_switch nct_unit" name="public_attr"
                    data-options='{ "list_select" : [ ["v3css_icon_sure" , "cl-ok" , "公开"] , [ "v3css_icon_lock" , "" , "隐私"]] }'>
                    <span class="v3css_control_icon v3css_icon_sure cl-ok"></span>
                    <span class="v3css_control_text">公开</span>
                </div>
        */
        $(this).on(g_clickevent, function(){
            var options             = $.data(this, 'v3ui_switch').options;
            var control_text        = $('.v3css_control_text', $(this));
            var control_icon        = $('.v3css_control_icon', $(this));
            var show_text           = control_text.text();

            // 切换列表索引，如果为1 则是当前选中值
            var switch_list_idx     = options.list_select.map(function(obj, i){if(obj[2] == show_text){return 1;}else{return 0}});
            var current_item        = options.list_select[switch_list_idx.indexOf(1)];
            var next_item           = options.list_select[0];

            // 不是最后一个元素，则下一个条目为切换元素
            if(switch_list_idx.indexOf(1) + 1 < options.list_select.length){
                next_item           = options.list_select[switch_list_idx.indexOf(1) + 1]
            }

            // 切换当前icon、icon颜色， 替换字
            control_icon.removeClass(current_item[0]).removeClass(current_item[1]);
            control_icon.addClass(next_item[0]).addClass(next_item[1]);
            control_text.text(next_item[2]);

            // 添加 onChange事件
            options.onChange.call($(this), next_item);
        });
    }

    $.fn.v3ui_switch = function(options, param){
        if (typeof(options) == 'string'){
            return options in $.fn.v3ui_switch.methods ? $.fn.v3ui_switch.methods[options](this, param) : null;
        }

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'v3ui_switch');
            if (state){
                $.extend(state.options, options);
            } else {
                $.data(this, 'v3ui_switch', {options: $.extend({},  $.fn.v3ui_switch.default, $(this).data('options'), options)});
                v3ui_switch_init.call(this);
            }
        });
    };

    $.fn.v3ui_switch.default = {
        onChange: function(){
        }
    };

    $.fn.v3ui_switch.methods = {
        val: function(othis){
            return $('.v3css_control_text', $(othis)).text();
        }
    };
})(jQuery);

(function ($) {
    /*
     *   支持V3SECTION的行内选编辑
     */

    //初始化line
    function v3ui_inline_edit_init(target) {
        var opts        = target.data('inline_edit').options;

        var o_input     = $('<input>').addClass('v3css_input').attr({'maxlength':opts.maxlength,'autocomplete':'off'}).appendTo(target);
        o_input.val(target.attr('value') || '');

        var obj_field = $(opts.data_target ,target);

        if(target.attr('value')){
            obj_field.html(target.attr('value'))
        }
        else{
            obj_field.html(opts.input_tip);
            obj_field.addClass('cl-tip')
        }
        var o_middle = $('.v3inline_middle' , target);

        // 点击显示input控件同时focus，影藏显示的值
        if(opts.not_edit != 'true'){
            target.bind('click' , function(){
                // 以.v3inline_middle元素设置input距离左边的距离

                var left_w = o_middle.position().left + 'px';
                var input_width = "100% - " + left_w;
                o_input.css({'left':left_w,"width" :"calc(" + input_width + ")"});

                obj_field.css('visibility' , "hidden");

                //o_input.attr('type' ,opts.input_type||'text')
                o_input[0].type = opts.input_type||'text';
                o_input.bind('input propertychange', function() {
                    if(opts.input_type == 'number' && o_input.val().length > opts.maxlength){
                        o_input.val(o_input.val().slice(0,opts.maxlength))
                    }
                    target.attr('value', o_input.val());
                });
                o_input.show();
                o_input.focus();
                return false;
            });
        }


        //onblur后显示值，隐藏input
        o_input.bind('blur' , function(){
            o_input.hide();

            if (o_input.val()){
                if (opts.input_type == 'password'){
                    //o_input.attr('type','text');          // 防止密码自动填充
                    o_input[0].type = 'text';
                    var show_text=  new Array(o_input.val().length + 1).join("•");
                    obj_field.html(show_text)
                }
                else {
                    obj_field.html(o_input.val());
                }
                if (obj_field.hasClass('cl-tip')){
                     obj_field.removeClass('cl-tip');
                }
            }
            else{
                obj_field.html(opts.input_tip);
                obj_field.addClass('cl-tip')
            }
            target.attr('value', o_input.val());
            opts.on_blur.call(target,o_input.val());
            obj_field.css('visibility' ,"visible");
            return false;
        });

    }

    $.fn. v3ui_inline_edit = function (options, param) {
        if (typeof options == 'string') {
            return $.fn.v3ui_inline_edit.methods[options](this, param);
        }

        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'inline_edit');
            var opts;
            if (state) {
                opts = $.extend(state.options, options);
                state.options = opts;
            } else {
                $.data(this, 'inline_edit', {
                    options: $.extend({}, $.fn.v3ui_inline_edit.defaults, options ,$(this).data('inlineedit'))
                });

                //初始化radio 和checkbox 控件
                v3ui_inline_edit_init($(this));
            }


        });
    };

    $.fn.v3ui_inline_edit.methods = {

        val: function (target) {
                return target.attr('value')

        },
        setVal:function (target , new_value) {
            var opts        = target.data('inline_edit').options;
            var obj_field = $(opts.data_target ,target);
            obj_field.html(new_value);
            $('input' , target).val(new_value);
            target.attr('value', new_value);
        },
        setTip: function (target, new_value) {
            var opts = target.data('inline_edit').options;
            var obj_field = $(opts.data_target, target);
            obj_field.html(new_value);
            obj_field.addClass('cl-tip');
            target.data('inline_edit').options.input_tip = new_value;
        },
        setMaxlength: function (target, new_value) {
            target.data('inline_edit').options.maxlength = new_value;
        },
        setInputtype: function (target, new_value) {
            target.data('inline_edit').options.input_type = new_value;
        }
    };

    $.fn.v3ui_inline_edit.defaults = {
       on_blur   :   function(new_value){},
       data_target : '.v3inline_middle'
    };

})(jQuery);


// *******************************************************************************

(function ($) {
    /*
     *   支持V3SECTION的行内选编辑
     */
    //初始化line
    function v3ui_inline_popup_init(target) {
        var opts        = target.data('inline_edit').options;

        var o_input     = $('<input>').addClass('v3css_input').attr({
            'maxlength':opts.maxlength,'autocomplete':'off'}
        ).appendTo(target);
        o_input.val(target.attr('value') || '');

        var obj_field = $(opts.data_target ,target);

        if(target.attr('value')){
            obj_field.html(target.attr('value'))
        }
        else{
            obj_field.html(opts.input_tip);
            obj_field.addClass('cl-tip')
        }
        var o_middle = $('.v3inline_middle' , target);

        // 点击显示input控件同时focus，影藏显示的值
        if(opts.not_edit != 'true'){
            target.bind('click' , function(){
                // 以.v3inline_middle元素设置input距离左边的距离
                return false;
            });
        }

        //onblur后显示值，隐藏input
        o_input.bind('blur' , function(){
            o_input.hide();

            if (o_input.val()){
                if (opts.input_type == 'password'){
                    //o_input.attr('type','text');          // 防止密码自动填充
                    o_input[0].type = 'text';
                    var show_text=  new Array(o_input.val().length + 1).join("•");
                    obj_field.html(show_text)
                }
                else {
                    obj_field.html(o_input.val());
                }
                if (obj_field.hasClass('cl-tip')){
                     obj_field.removeClass('cl-tip');
                }
            }
            else{
                obj_field.html(opts.input_tip);
                obj_field.addClass('cl-tip')
            }
            target.attr('value', o_input.val());
            opts.on_blur.call(target,o_input.val());
            obj_field.css('visibility' ,"visible");
            return false;
        });

    }

    $.fn. v3ui_inline_popup = function (options, param) {
        if (typeof options == 'string') {
            return $.fn.v3ui_inline_popup.methods[options](this, param);
        }
        options = options || {};
        return this.each(function () {
            var state = $.data(this, 'inline_edit');
            var opts;
            if (state) {
                opts = $.extend(state.options, options);
                state.options = opts;
            } else {
                $.data(this, 'inline_edit', {
                    options: $.extend({}, $.fn.v3ui_inline_popup.defaults, options ,$(this).data('inlineedit'))
                });
                //初始化radio 和checkbox 控件
                v3ui_inline_popup_init($(this));
            }
        });
    };

    $.fn.v3ui_inline_popup.methods = {

        val: function (target) {
            return target.attr('value')

        },
        setVal:function (target , new_value) {
            var opts        = target.data('inline_edit').options;
            var obj_field = $(opts.data_target ,target);
            obj_field.html(new_value);
            $('input' , target).val(new_value);
            target.attr('value', new_value);
        },
        setTip: function (target, new_value) {
            var opts = target.data('inline_edit').options;
            var obj_field = $(opts.data_target, target);
            obj_field.html(new_value);
            obj_field.addClass('cl-tip');
            target.data('inline_edit').options.input_tip = new_value;
        },
        setMaxlength: function (target, new_value) {
            target.data('inline_edit').options.maxlength = new_value;
        },
        setInputtype: function (target, new_value) {
            target.data('inline_edit').options.input_type = new_value;
        }
    };

    $.fn.v3ui_inline_popup.defaults = {
       on_blur   :   function(new_value){},
       data_target : '.v3inline_middle'
    };

})(jQuery);

// *******************************************************************************


(function ($) {
    /*
     * 支持V3SECTION的行内选择
     */
    function v3ui_inline_select_init(target){
        var opts  = target.data('inlineselect');
        var state = $.data(target[0] , 'inline_select');

        var obj_field = $(opts.data_target || '.v3inline_left' , target);
        obj_field.html(target.attr('value') ||(target.attr('defaut')|| '未设置'));

        target.bind('click' , function(){
            var n_opts  = target.data('inlineselect');
            $.choice(n_opts.data_list , function (obj) {
                    if(obj){
                        obj_field.html(obj[1]);
                        target.attr('value', obj[1]);

                        // 触发新值变更回调
                        state.options.on_change.call(target, obj[1]);
                    }
                },n_opts.data_title , n_opts.data_list.index(target.attr('value')) + 1);
            return false;
        });
    }

    $.fn.v3ui_inline_select = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_inline_select.methods ? $.fn.v3ui_inline_select.methods[options](this, param) : null;

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'inline_select');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'inline_select', {
                    options: $.extend({}, $.fn.v3ui_inline_select.defaults, options)
                });
                v3ui_inline_select_init($(this));
            }
        });
    };

    $.fn.v3ui_inline_select.defaults  = {
        on_change   :   function(new_value){}
    };

    $.fn.v3ui_inline_select.methods   = {
        val         :   function(target){
                            return target.attr('value');
                        },
        on_update   :   function(target, data_list){
            target.data('inlineselect', {data_list: data_list});
        }
    };
})(jQuery);


(function ($) {
    /*
     * 支持V3SECTION的行内选择,支持值和显示分开
     */
    function v3ui_inline_select2_init(target){
        var opts  = target.data('inlineselect');
        var state = $.data(target[0] , 'inline_select');

        var obj_field = $(opts.data_target || '.v3inline_left' , target);

        var list_select_text  = [];
        var list_select_value = [];
        for(var i in opts.data_list){
            list_select_text.push(i)
            list_select_value.push(opts.data_list[i])
        }
        if (target.attr('value')){
            obj_field.html(list_select_value[list_select_text.index(target.attr('value'))]);
        }
        else if(target.attr('title')){
            obj_field.html(target.attr('title')) ;
        }
        else{
             obj_field.html('未设置');
        }
        target.bind('click' , function(){
            $.choice(list_select_value , function (obj) {
                    if(obj){
                        obj_field.html(obj[1]);
                        target.attr('value', list_select_text[obj[0]-1]);

                        // 触发新值变更回调
                        state.options.on_change.call(target,list_select_text[obj[0]]-1);
                    }
                },opts.data_title , list_select_text.index(target.attr('value'))+1 );
            return false;
        });
    }

    $.fn.v3ui_inline_select2 = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_inline_select2.methods ? $.fn.v3ui_inline_select2.methods[options](this, param) : null;

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'inline_select');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'inline_select', {
                    options: $.extend({}, $.fn.v3ui_inline_select2.defaults, options)
                });
                v3ui_inline_select2_init($(this));
            }
        });
    };

    $.fn.v3ui_inline_select2.defaults  = {
        on_change   :   function(new_value){}
    };

    $.fn.v3ui_inline_select2.methods   = {
        val         :   function(target){
                            return target.attr('value');
                        }
    };
})(jQuery);


(function ($) {
    /*
     * 支持V3SECTION的行内多选选择
     */
    function sort_array_via_weight(array) {
        // 根据权重对array的元素进行排序
        var lw = {'语文': 1, '数学': 2, '英语': 3};
        var tmp = [];
        var result = [];
        for (var i = 0; i < array.length; i++) {
            tmp.push(lw[array[i]])
        }
        tmp.sort();
        for (var i = 0; i < tmp.length; i++) {
            for(var obj in lw){
                if(lw[obj] == tmp[i]){
                    result.push(obj);
                }
            }
        }
        return result;
    }

    function v3ui_inline_select_many_init(target){
        var opts  = target.data('inlineselect');
        var state = $.data(target[0] , 'inline_select');

        var obj_field = $(opts.data_target || '.v3inline_left' , target);
        obj_field.html(target.attr('value') ||(target.attr('defaut')|| '未设置'));

        target.bind('click' , function(){
            $.choices(opts.data_list , function (obj) {
                    if(obj){
                        selected_list = obj_field.html().split(",");
                        if(selected_list.indexOf("未设置") > -1){
                            var idx = $.inArray("未设置", selected_list);
                            selected_list.splice(idx, 1);
                        }
                        if(selected_list.indexOf(obj[1]) > -1){
                            var idx = $.inArray(obj[1], selected_list);
                            selected_list.splice(idx, 1);
                        }else{
                            selected_list.push(obj[1]);
                        }
                        selected_list = sort_array_via_weight(selected_list)
                        if(selected_list.length == 0){
                            selected_list.push("未设置");
                        }
                        obj_field.html(selected_list.join(","));

                        target.attr('value', selected_list.join(","));
                        // console.log(target);
                        // 触发新值变更回调
                        state.options.on_change.call(target, obj[1]);
                    }
                }, opts.data_title, target.attr('value'));
            return false;
        });
    }

    $.fn.v3ui_inline_select_many = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_inline_select_many.methods ? $.fn.v3ui_inline_select_many.methods[options](this, param) : null;

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'inline_select');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'inline_select', {
                    options: $.extend({}, $.fn.v3ui_inline_select_many.defaults, options)
                });
                v3ui_inline_select_many_init($(this));
            }
        });
    };

    $.fn.v3ui_inline_select_many.defaults  = {
        on_change   :   function(new_value){
        }
    };

    $.fn.v3ui_inline_select_many.methods   = {
        val         :   function(target){
            return target.attr('value');
        }
    };
})(jQuery);


(function ($) {
    /*
     * 支持V3SECTION的行内编辑头像
     */
    function v3ui_inline_headimg_init(target){
        $('.v3ui_image_upload' ,target).v3ui_image_upload();
        var o_value = target.attr('value');
        if (target.attr('value')){
             $('.nbiu_preview' ,target).eq(1).attr('src', o_value).css('display','inline');
        }
        target.css('line-height',$('.v3ui_image_upload').height()+'px')
        $('.nbiu_form' , target).css('margin-right' , '0px');

        if ($('.v3inline_right_block' , target).length > 0){
            var apart_left ='-' + $('.v3inline_right_block' , target).position().left+'px';
            $('.nbiu_imginput',target).eq(1).css({'left':apart_left ,'width':target.innerWidth()})
        }
    }


    $.fn.v3ui_inline_headimg = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_inline_headimg.methods ? $.fn.v3ui_inline_headimg.methods[options](this, param) : null;

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'inline_headimg');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'inline_headimg', {
                    options: $.extend({}, $.fn.v3ui_inline_headimg.defaults, options)
                });
                v3ui_inline_headimg_init($(this));
            }
        });
    };

    $.fn.v3ui_inline_headimg.methods  = {
         update  :   function(target , options){
             $('.nbiu_preview' ,target).eq(1).attr('src', options.value).css('display','inline');
             $('.nbiu_form' ,target).eq(1).attr('fileupload' , options.value);
         }
    };

    $.fn.v3ui_inline_headimg.defaults   = {

    };
})(jQuery);

(function ($) {
    /*
     *
     */
    function v3ui_section_inline_more_init(target){
        // 计算是否需要MOREBOX：根据配置显示的行数*每行元素的数量是否超过总数量
        $('img[data-original]' ,target).lazyload_image().lazyload('update')
        var state        = target.data('options');
        if (!state || !state.count_per_line)
            return;

        var count_item     = $('.v3item' , target).length;
        var line_visible   = state.line_visible || 1;
        var count_per_line = state.count_per_line;

        $('.v3items_more_upright,.v3items_more_bottom' , target).remove();
        if (line_visible * count_per_line >= count_item){
            return target;
        }

        $('.v3item:gt(' + (line_visible * count_per_line - 1) + ')' , target).addClass('v3section_more_area').hide();

        // 根据配置决定是在右上角还是下方创建展开和收缩
        var style_inline_more = state.style_inline_more || 'upright';
        var obj_expand_click   = $('<div>').addClass('v3section_more_area cl-master').html('全部').prepend($('<span>').addClass('v3css_icon_movedown'));
        var obj_collapse_click = $('<div>').addClass('v3section_more_area cl-master').html('收缩').prepend($('<span>').addClass('v3css_icon_moveup')).hide();

        var obj_click = null;
        if (style_inline_more == 'upright')
            obj_click = $('<div>').addClass('v3items_more_upright').append(obj_expand_click).append(obj_collapse_click).appendTo(target);
        else
            obj_click = $('<div>').addClass('v3items_more_bottom').append(obj_expand_click).append(obj_collapse_click).appendTo($('.v3items' , target));

        // 响应用户对创建和收缩的点击操作
        obj_click.bind('click' , function(){
            $('.v3section_more_area' , target).toggle(0 , function(){

            });
            return false;
        });
    }

    $.fn.v3ui_section_inline_more = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_section_inline_more.methods ? $.fn.v3ui_section_inline_more.methods[options](this, param) : null;

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'section_inline_more');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'section_inline_more', {
                    options: $.extend({}, $.fn.v3ui_section_inline_more.defaults, options)
                });
            }
            v3ui_section_inline_more_init($(this));
        });
    };

    $.fn.v3ui_section_inline_more.methods  = {
    };

    $.fn.v3ui_section_inline_more.defaults   = {

    };
})(jQuery);

(function ($) {
    /*
     * 支持微信朋友圈预览初始化
     */
    $.fn.v3ui_wx_timeline = function(options, param){

        var share_info = on_appcmd_wxshare();
        return this.each(function(){
            var target = $(this);
            $('a' , target).attr('hrefs' , share_info.url_link);
            $('#wx_thumb img' , target).attr('src' , share_info.url_image);
            $('#wx_text' , target).html(share_info.share_friend);
        });
    };
})(jQuery);

(function ($) {
    /*
     * 支持微信好友分享预览初始化
     */
    $.fn.v3ui_wx_friend = function(options, param){

        var share_info = on_appcmd_wxshare();
        return this.each(function(){
            var target = $(this);
            $('a' , target).attr('hrefs' , share_info.url_link);
            $('#wx_thumb img' , target).attr('src' , share_info.url_image);
            $('#wx_title' , target).html(share_info.share_title);
            $('#wx_text' , target).html(share_info.share_content);
        });
    };
})(jQuery);

(function ($) {
    /*
     * 支持APP布局中左1右4的方式
     */
    function v3ui_layout_1plus4_init(target){
	    // 调整高度，让左边是正方形
        var height = Math.floor(target.width() / 4);
	    $('td' , target).height(height);

	    // 调整第一个图标的大小
	    var obj_import_img = $('td:eq(0) .icon_img img' , target);
        obj_import_img.load(function(){
            var height_img     = obj_import_img.width();
            obj_import_img.width(height_img * 2.5).height(height_img * 2.5);
        });
    }

    $.fn.v3ui_layout_1plus4 = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_layout_1plus4.methods ? $.fn.v3ui_layout_1plus4.methods[options](this, param) : null;

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'layout_1plus4');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'layout_1plus4', {
                    options: $.extend({}, $.fn.v3ui_layout_1plus4.defaults, options)
                });
                v3ui_layout_1plus4_init($(this));
            }
        });
    };

    $.fn.v3ui_layout_1plus4.methods  = {
    };

    $.fn.v3ui_layout_1plus4.defaults   = {

    };
})(jQuery);

// 对于首页中因为点读的区域布局和屏幕宽度有关，导致点读图标可能在iPad还不够大，暂时忽略该问题
// 先把焦点放到如何对iPad进行屏幕字体适配上来
//(function ($) {
//    /*
//     *
//     */
//    function v3ui_layout_iconresize_init(target){
//        // 对屏幕上的app_v3appicon进行伸缩
//        // 总体原则就是横向与纵向两边空白占比要大于10%（不要太紧）小于30%（不要太松）
//        $('.v3appicon' , target).each(function(){
//	        var othis = $(this);
//	        var ocontainer = othis.closest('td');
//	        if (!ocontainer.length || ocontainer.hasClass('v3appicon_disable_resize'))
//	            return;
//
//	        var oimage = $('.icon_img img' , othis);
//	        var oinfo  = $('.icon_info' , othis);
//	        var width_image = oimage.width();
//	        var width_text  = Math.max($('.icon_text span' , othis).width() , $('.icon_tip span' , othis).width());
//	        var width_icon  = Math.max(width_image , width_text);
//	        var height_icon = oinfo.offset().top + oinfo.outerHeight() - oimage.offset().top;
//	        var width_container  = ocontainer.innerWidth();
//	        var height_container = ocontainer.innerHeight();
//
//	        var rate_free_width  = Math.round((width_container - width_icon) * 100 / width_container);
//	        var rate_free_height = Math.round((height_container - height_icon) * 100 / height_container);
//
//	        var rate_resize = null;
//	        if (rate_free_width > rate_free_height){
//		        // 横向空的大，纵向空的窄，则考量纵向空余是否满足要求
//		        var ver_min_free = 15, ver_max_free = 40;
//
//		        if (rate_free_height < ver_min_free){
//			        // 纵向空闲小于15%，小屏手机，太拥挤需要收缩
//			        rate_resize = height_container * (100 - ver_min_free) * 0.01 / height_icon;
//		        }
//		        else if (rate_free_height > ver_max_free){
//			        // 纵向空闲大于35%，大屏手机，太宽松需要放大
//			        rate_resize = height_container * (100 - ver_max_free) * 0.01 / height_icon;
//		        }
//	        }
//	        else{
//		        // 纵向空的大，横向空的窄，则考量横向空余是否满足要求
//		        var hor_min_free = 15, hor_max_free = 40;
//
//		        if (rate_free_width < hor_min_free){
//			        // 纵向空闲小于15%，小屏手机，太拥挤需要收缩
//			        rate_resize = width_container * (100 - hor_min_free) * 0.01 / width_icon;
//		        }
//		        else if (rate_free_width > hor_max_free){
//			        // 纵向空闲大于35%，大屏手机，太宽松需要放大
//			        rate_resize = width_container * (100 - hor_max_free) * 0.01 / width_icon;
//		        }
//	        }
//
//	        if (rate_resize) {
//                oimage.height(oimage.height() * rate_resize);
//                oinfo.css('font-size', (parseInt(oinfo.css('font-size')) * rate_resize) + 'px');
//    	        //$('.icon_tip span' , othis).html(rate_free_width + '%,' + rate_free_height + '%');
//	        }
//        });
//    }
//
//
//    $.fn.v3ui_layout_iconresize = function(options, param){
//        if (typeof(options) == 'string')
//            return options in $.fn.v3ui_layout_iconresize.methods ? $.fn.v3ui_layout_iconresize.methods[options](this, param) : null;
//
//        options = options || {};
//        return this.each(function(){
//            var state = $.data(this, 'layout_iconresize');
//            if (state){
//                $.extend(state.options, options);
//            } else {
//                state = $.data(this, 'layout_iconresize', {
//                    options: $.extend({}, $.fn.v3ui_layout_iconresize.defaults, options)
//                });
//                v3ui_layout_iconresize_init($(this));
//            }
//        });
//    };
//
//    $.fn.v3ui_layout_iconresize.methods  = {
//    };
//
//    $.fn.v3ui_layout_iconresize.defaults   = {
//
//    };
//})(jQuery);

(function ($) {
    /*
     * iOS中fixed在键盘浮动的时候有问题，通过绝对定位来解决和规避
     */

    function v3ui_fix_bottom_bar_on_screen(target){
        var size_win   = window.getWinSize();
        var pos_scroll = window.getScrollPos();
        var height_bar = target.outerHeight();

        if (!g_ios_keyborad_height){
            target.css('bottom' , '0px').css('top' , 'auto').css('position' , 'fixed');
        }
        else{
            //target.css('position' , 'absolute').css('bottom' , 'auto').css('top' , (size_win[1] - height_bar + pos_scroll[1] - g_ios_keyborad_height) + 'px');
            target.css('position' , 'absolute').css('bottom' , 'auto').css('top' , $('body').height() + 'px');

            //$('.v3ui_richdiv').html('size_win[1]=' + size_win[1] + '<br>' + 'height_bar=' + height_bar + '<br>' + 'pos_scroll[1]=' + pos_scroll[1] + '<br>' + 'g_ios_keyborad_height=' + g_ios_keyborad_height + '<br>' + delta_y)
        }
    }

    function v3ui_fix_bottom_bar_init(target){
        // 则自动body增加margin-bottom
        $('body').css('margin-bottom' , target.outerHeight() + 'px');

        if (g_app_os != 'ios' || target.css('position') != 'fixed')
            return target;

        $(window).resize(function(){
            $('body').css('margin-bottom' , target.outerHeight() + 'px');
            v3ui_fix_bottom_bar_on_screen(target);
        });

        v3ui_fix_bottom_bar_on_screen(target);
    }

    $.fn.v3ui_fix_bottom_bar_delay = function(options, param){
        if (typeof(options) == 'string')
            return options in $.fn.v3ui_fix_bottom_bar_delay.methods ? $.fn.v3ui_fix_bottom_bar_delay.methods[options](this, param) : null;

        options = options || {};
        return this.each(function(){
            var state = $.data(this, 'fix_bottom_bar');
            if (state){
                $.extend(state.options, options);
            } else {
                state = $.data(this, 'fix_bottom_bar', {
                    options: $.extend({}, $.fn.v3ui_fix_bottom_bar_delay.defaults, options)
                });
                v3ui_fix_bottom_bar_init($(this));
            }
        });
    };

    $.fn.v3ui_fix_bottom_bar_delay.methods  = {
    };

    $.fn.v3ui_fix_bottom_bar_delay.defaults   = {

    };
})(jQuery);